/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	$Id: MastrBld.h,v 1.16.2.1 2002/11/26 23:39:48 wjb Exp $
____________________________________________________________________________*/

#ifndef Included_MastrBld_h	/* [ */
#define Included_MastrBld_h

/* This file can be used to control the build settings for the
   entire sdk and client workspace. Set OVERRIDE_BUILDFLAGS
   to 1 in the client project and the settings in this file will be 
   used. */

#ifdef OVERRIDE_BUILDFLAGS
/* 
Set these values for the entire build
*/

/*____________________________________________________________________________
	Client Version information
____________________________________________________________________________*/

#define PGPVERSIONSTRING		"8.0" 
#define PGPVERSIONMAJOR			8
#define PGPVERSIONMINOR			0
#define PGPVERSIONSUBMINOR		0
#define PGPVERSIONSUBSUBMINOR   0

#define PGPVERSIONRELEASESTAGE	1	/* 0 = Development, 1 = Alpha, */
									/* 2 = Beta, 3 = Release */
#define PGPBUILDNUMBER			"101" 
#define PGPCOMPANYNAME			"PGP Corporation"
#define	PGPCOPYRIGHT			"Copyright  2002 PGP Corporation"
#define PGPTRADEMARKS			"Pretty Good Privacy, PGP"
#define PGPPRODUCTNAME			"PGP"

/*____________________________________________________________________________
	License information
____________________________________________________________________________*/

#define PGPPRODUCTID			0	/* For use with license code */
#define PGP_LICENSENUMBERS		1	/* 0 =  No License Check, 1 = License Check */
#define PGP_LICENSEGRACEPERIOD	60	/* Expiration date extension in days */
									/* Only applies to non-eval licenses */

/*____________________________________________________________________________
	SDK Version information
____________________________________________________________________________*/

#define PGPSDK_SHORT_VERSION_STRING		"3.0"

#define PGPSDK_MAJOR_VERSION			3
#define PGPSDK_MINOR_VERSION			0
#define PGPSDK_SUBMINOR_VERSION			0
#define PGPSDK_RELEASE_STAGE			1	/* 0 = Development, 1 = Alpha, */
											/* 2 = Beta, 3 = Release */
#define PGPSDK_BUILD					1

#define PGPSDK_BUILDNUMBER				"101"
#define PGPSDK_INSTALLEDWITH			"PGP 8.0 (Build 101 Alpha)"

#define PGPSDK_COPYRIGHT 	"Copyright (C) 2002 PGP Corporation, All rights reserved."

/*____________________________________________________________________________
	Other Client flags
____________________________________________________________________________*/

#ifndef PGP_BETA
#define PGP_BETA					1		// zero for release
#endif

#define UNFINISHED_CODE_ALLOWED		1		// *Must* be set to zero for release

/*____________________________________________________________________________
	Beta and Eval timeout periods
____________________________________________________________________________*/

#define PGP_BETA_DAYS				60

/*____________________________________________________________________________
	SDK Algorithm support
____________________________________________________________________________*/

#define PGP_RSA				1
#define PGP_RSA_KEYGEN		1

#define PGP_USECAPIFORRSA	0	/* Try to use Microsoft CAPI library for RSA */
#define PGP_USECAPIFORMD2	0	/* Try to use Microsoft CAPI library for MD2 */
#define PGP_USEBSAFEFORRSA  0	/* Use RSA's BSAFE library for RSA support */
#define PGP_USEPGPFORRSA	1	/* Use the PGP implementation for RSA support */
#define PGP_USERSAREF		0	/* Use the non-commercial RSAREF library for RSA */

#define PGP_EC				0	/* Elliptic Curve support */

/* These probably will always be on */
#define PGP_CAST5		1
#define PGP_DES3		1
#define PGP_IDEA		1
#define PGP_TWOFISH		1
#define PGP_AES			1

/*____________________________________________________________________________
	Other optional SDK flags
____________________________________________________________________________*/

#ifdef PGP_WIN32
	#define PGP_INTEL_RNG_SUPPORT	0 // 1
#else
	#define PGP_INTEL_RNG_SUPPORT	0
#endif

/* Allows turning off signing/verification capability in library */
#ifndef PGP_SIGN_DISABLE
	#define PGP_SIGN_DISABLE	0
#endif

#ifndef PGP_VERIFY_DISABLE
	#define PGP_VERIFY_DISABLE	0
#endif

/* Allows turning off encryption/decryption capability in library */
#ifndef PGP_ENCRYPT_DISABLE
	#define PGP_ENCRYPT_DISABLE	0
#endif

#ifndef PGP_DECRYPT_DISABLE
	#define PGP_DECRYPT_DISABLE	0
#endif

#endif /* OVERRIDE_BUILDFLAGS */

#endif /* ] Included_MastrBld_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
