#!/usr/bin/perl -w

use File::Copy;
use File::Path;

my $cwd = `pwd`;
my $projects = [
	{
		name		=> "PFL",
		pbxproj		=> "../../../libs2/pfl/osx",
		targets		=> [ qw(configure libpfl.a) ],
	},
	{
		name		=> "PGP.framework",
		pbxproj		=> "../../../libs2/pgpsdk/osx/framework",
		targets		=> [ qw(configure PGP.framework) ],
	},
	{
		name		=> "PGPservice",
		pbxproj		=> "../../../libs2/pgpsdk/osx/service",
		targets		=> [ qw(PGPservice) ],
	},
	{
		name		=> "PGPclient",
		pbxproj		=> "../../clientlib/osx",
		targets		=> [ qw(PGPclient.framework) ],
	},
	{
		name		=> "PGPdiskDriver",
		pbxproj		=> "../../diskdriver/osx/PGPdiskDriver.pbproj",
		targets		=> [ qw(PGPdiskDriver disktest) ],
	},
	{
		name		=> "load_pgpdisk",
		pbxproj		=> "../../diskdriver/osx/load_pgpdisk.pbproj",
		targets		=> [ qw(load_pgpdisk) ],
	},
	{
		name		=> "PGPdiskEngine",
		pbxproj		=> "../../diskengine/osx",
		targets		=> [ qw(PGPdiskEngine PGPdiskEngineTest) ],
	},
	{
		name		=> "PGPdiskBundle",
		pbxproj		=> "../../diskapp/osx",
		targets		=> [ qw(PGPdisk) ],
	},
	{
		name		=> "PGPkeysBundle",
		pbxproj		=> "../../keys/osx",
		targets		=> [ qw(PGPkeys) ],
	},
	{
		name		=> "PGP.app",
		pbxproj		=> "../../console/osx",
		targets		=> [ qw(PGP) ],
	}
];

chomp($cwd);

foreach my $project (@$projects)	{

	my $newdir = "$cwd/$project->{pbxproj}";
	$newdir =~ s/\n//gm;
	chdir("$newdir");

        foreach my $target (@{$project->{targets}})             {
		my $cwd = `pwd`;
		chomp($cwd);
                my $cpp_headermap_file = "$cwd/build/intermediates/$target.build/Headermaps/$target.hmap";
                my $dstroot = "/";
                my $objroot = "$cwd/build/intermediates";

                print "*** Building $project->{name} ($target)\n";     
                open(PBXBUILD, "pbxbuild -target $target -buildstyle \"Development\" CPP_HEADERMAP_FILE=$cpp_headermap_file DSTROOT=$dstroot OBJROOT=$objroot 2>&1 |");
                while (<PBXBUILD>)      { print; }
                close(PBXBUILD);
        }

	chdir($cwd);
}

if (-d "../../clientlib/osx/build/PGPclient.framework")	{
	mkpath("../../console/osx/build/PGP.app/Contents/Frameworks");
	`cp -R ../../clientlib/osx/build/PGPclient.framework ../../console/osx/build/PGP.app/Contents/Frameworks/`;
}

if (-e "../../diskengine/osx/build/PGPdiskEngine")	{
	mkpath("../../diskapp/osx/build/PGPdisk.bundle/Contents/Resources");
	`cp ../../diskengine/osx/build/PGPdiskEngine ../../diskapp/osx/build/PGPdisk.bundle/Contents/Resources/`;
}

if (-d "../../diskdriver/osx/build/PGPdiskDriver.kext")	{
	mkpath("../../diskapp/osx/build/PGPdisk.bundle/Contents/Resources");
	`cp -R ../../diskdriver/osx/build/PGPdiskDriver.kext ../../diskapp/osx/build/PGPdisk.bundle/Contents/Resources/`;
}

if (-e "../../diskdriver/osx/build/load_pgpdisk")	{
	mkpath("../../diskapp/osx/build/PGPdisk.bundle/Contents/Resources");
	`cp ../../diskdriver/osx/build/load_pgpdisk ../../diskapp/osx/build/PGPdisk.bundle/Contents/Resources/`;
}

if (-d "../../diskapp/osx/build/PGPdisk.bundle")	{
	mkpath("../../console/osx/build/PGP.app/Contents/PlugIns");
	`cp -R ../../diskapp/osx/build/PGPdisk.bundle ../../console/osx/build/PGP.app/Contents/PlugIns/`;
}

if (-d "../../keys/osx/build/PGPkeys.bundle")	{
	mkpath("../../console/osx/build/PGP.app/Contents/PlugIns");
	`cp -R ../../keys/osx/build/PGPkeys.bundle ../../console/osx/build/PGP.app/Contents/PlugIns/`;
}

if (-d "../../console/osx/build/PGP.app")	{
	`cp -R ../../console/osx/build/PGP.app /Applications/`;
}

print <<EOM;





***** Be sure to chown root and set the suid bit on load_pgpdisk in /Applications/PGP.app and PGPdisk.bundle *****




EOM


		
		
	
