#!/usr/bin/perl

use Data::Dumper;

delete($ENV{OBJROOT});
delete($ENV{SRCROOT});
delete($ENV{DSTROOT});
delete($ENV{SYMROOT});

my $deployment = 0;
my $cwd = `pwd`;
my $action = "";
my $supported_builds =
{
	"PFL"	=>
	{
		"project_dir"	=> "../../../libs2/pfl/osx",
		"targets"		=>
		{
			"configure"		=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
					},
					"Deployment"	=>
					{
					},
				},
			},
			"libpfl.a"		=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
					},
					"Deployment"	=>
					{
					},
				},
			},
		},
	},
	"PGP.framework"	=>
	{
		"project_dir"	=> "../../../libs2/pgpsdk/osx/framework",
		"targets"		=>
		{
			"PGP.framework"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGP.framework",
						"install_path"	=> "../../../clients2/console/osx/build/PGP.app/Contents/SharedFrameworks/PGP.framework",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGP.framework",
						"install_path"	=> "../../../clients2/console/osx/build/PGP.app/Contents/SharedFrameworks/PGP.framework",					
					},
				},
			},
			"configure"		=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
					},
					"Deployment"	=>
					{
					},
				},
			},
		},
	},
	"PGPui.framework"	=>
	{
		"project_dir"	=> "../../../libs2/pgpsdk/osx/uiframework",
		"targets"		=>
		{
			"PGPui.framework"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"	=> "build/PGPui.framework",
						"install_path"	=> "../../../clients2/console/osx/build/PGP.app/Contents/SharedFrameworks/PGPui.framework",
					},
					"Deployment"	=>
					{
						"product"	=> "build/PGPui.framework",
						"install_path"	=> "../../../clients2/console/osx/build/PGP.app/Contents/SharedFrameworks/PGPui.framework",
					},
				},
			},
		},
	},
	"PGPservice"	=>
	{
		"project_dir"	=> "../../../libs2/pgpsdk/osx/service",
		"targets"		=>
		{
			"PGPservice"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGPservice.app",
						"install_path"	=> "../framework/build/PGP.framework/Resources/PGPservice.app",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPservice.app",
						"install_path"	=> "../framework/build/PGP.framework/Resources/PGPservice.app",
					},
				},
			},
		},
	},
	"PGPclient"	=>
	{
		"project_dir"	=> "../../clientlib/osx",
		"targets"		=>
		{
			"PGPclient.framework"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGPclient.framework",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/Frameworks/PGPclient.framework",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPclient.framework",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/Frameworks/PGPclient.framework",
					},
				},
			},
		},
	},
	"PGPcontext"	=>
	{
		"project_dir"	=> "../../context/osx",
		"targets"		=>
		{
			"PGPcontext"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGPcontext.plugin",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/PlugIns/PGPmail.bundle/Contents/Resources/PGPcontext.plugin",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPcontext.plugin",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/PlugIns/PGPmail.bundle/Contents/Resources/PGPcontext.plugin",
					},
				},
			},
		},
	},
	"PGPkeys"	=>
	{
		"project_dir"	=> "../../keys/osx",
		"targets"		=> 
		{
			"PGPkeys"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGPkeys.bundle",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/PlugIns/PGPkeys.bundle",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPkeys.bundle",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/PlugIns/PGPkeys.bundle",
					},
				},
			},
		},		
	},
	"PGPdisk"	=>
	{
		"project_dir"	=> "../../diskapp/osx",
		"targets"		=>
		{
			"PGPdisk"	=>
			{
				"buildstyles"	=> 
				{
					"Development"	=>
					{
						"product"		=> "build/PGPdisk.bundle",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/PlugIns/PGPdisk.bundle",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPdisk.bundle",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/PlugIns/PGPdisk.bundle",
					},
				},
			},
		},
	},
	"PGPdiskDriver"	=>
	{
		"project_dir"	=> "../../diskdriver/osx",
		"targets"		=>
		{
			"PGPdiskDriver"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGPdiskDriver.kext",
						"install_path"	=> "../../diskapp/osx/build/PGPdisk.bundle/Contents/Resources/PGPdiskDriver.kext",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPdiskDriver.kext",
						"install_path"	=> "../../diskapp/osx/build/PGPdisk.bundle/Contents/Resources/PGPdiskDriver.kext",
					},
				},
			},
			"load_pgpdisk"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/load_pgpdisk",
						"install_path"	=> "../../diskapp/osx/build/PGPdisk.bundle/Contents/Resources/load_pgpdisk",
					},
					"Deployment"	=>
					{
						"product"		=> "build/load_pgpdisk",
						"install_path"	=> "../../diskapp/osx/build/PGPdisk.bundle/Contents/Resouces/load_pgpdisk",
					},
				},
			},
		},
	},
	"PGPdiskEngine"	=>
	{
		"project_dir"	=> "../../diskengine/osx",
		"targets"		=>
		{
			"PGPdiskEngine"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGPdiskEngine",
						"install_path"	=> "../../diskapp/osx/build/PGPdisk.bundle/Contents/Resources/PGPdiskEngine",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPdiskEngine",
						"install_path"	=> "../../diskapp/osx/build/PGPdisk.bundle/Contents/Resources/PGPdiskEngine",
					},
				},
			},
		},
	},
	"PGPmail"	=>
	{
		"project_dir"	=> "../../mail/osx",
		"targets"	=>
		{
			"PGPmail"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGPmail.bundle",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/PlugIns/PGPmail.bundle",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPmail.bundle",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/PlugIns/PGPmail.bundle",
					},
				},
			},
		},
	},
	"PGPmailViewer"	=>
	{
		"project_dir"	=> "../../mailviewer/osx",
		"targets"	=>
		{
			"PGPmailViewer"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGPmail.mailbundle",
						"install_path"	=> "../../mail/osx/build/PGPmail.bundle/Contents/Resources/PGPmail.mailbundle",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPmail.mailbundle",
						"install_path"	=> "../../mail/osx/build/PGPmail.bundle/Contents/Resources/PGPmail.mailbundle",
					},
				},
			},
		},
	},
	"PGPnet"	=>
	{
		"project_dir"	=> "../../netapp/osx",
		"targets"	=>
		{
			"PGPnetApp"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGPnet.bundle",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/PlugIns/PGPnet.bundle",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPnet.bundle",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/PlugIns/PGPnet.bundle",
					},
				},
			},
		},
	},
	"PGPnet.kext"	=>
	{
		"project_dir"	=> "../../netdriver/osx",
		"targets"	=>
		{
			"PGPnet.kext"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGPnet.kext",
						"install_path"	=> "../../netapp/osx/build/PGPnet.bundle/Contents/Resources/PGPnet.kext",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPnet.kext",
						"install_path"	=> "../../netapp/osx/build/PGPnet.bundle/Contents/Resources/PGPnet.kext",
					},
				},
			},
		},
	},
	"PGPnetService"	=>
	{
		"project_dir"	=> "../../service/osx",
		"targets"	=>
		{
			"PGPnetService"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGPnetService",
						"install_path"	=> "../../netapp/osx/build/PGPnet.bundle/Contents/Resources/PGPnetService",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPnetService",
						"install_path"	=> "../../netapp/osx/build/PGPnet.bundle/Contents/Resources/PGPnetService",
					},
				},
			},
		},
	},
	"PGPnetServiceUI"	=>
	{
		"project_dir"	=> "../../service/osx",
		"targets"	=>
		{
			"PGPnetServiceUI"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGPnetServiceUI.app",
						"install_path"	=> "../../netapp/osx/build/PGPnet.bundle/Contents/Resources/PGPnetServiceUI.app",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPnetServiceUI.app",
						"install_path"	=> "../../netapp/osx/build/PGPnet.bundle/Contents/Resources/PGPnetServiceUI.app",
					},
				},
			},
		},
	},
	"EntourageInstall"	=>
	{
		"project_dir"	=> "../../entourage/osx/installer",
		"targets"	=>
		{
			"Entourage Scripts Installer"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"	=> "build/entourage_install",
					},
					"Deployment"	=>
					{
						"product"	=> "build/entourage_install",
					},
				},
			},
		},
	},
	"PGP"	=>
	{
		"project_dir"	=> "../../console/osx",
		"targets"		=>
		{
			"installtool"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/installtool",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/Resources/installtool",
					},
					"Deployment"	=>
					{
						"product"		=> "build/installtool",
						"install_path"	=> "../../console/osx/build/PGP.app/Contents/Resources/installtool",
					},
				},
			},
			"PGPinstaller"	=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"product"		=> "build/PGPinstaller.app",
					},
					"Deployment"	=>
					{
						"product"		=> "build/PGPinstaller.app",
					},
				},
			},
			"Console"		=>
			{
				"buildstyles"	=>
				{
					"Development"	=>
					{
						"postbuild"		=> \&PGP_postbuild,
					},
					"Deployment"	=>
					{
						"postbuild"		=> \&PGP_postbuild,					
					},
				},
			}
		}
	},	
};

chomp($cwd);

if ($ENV{"DEPLOYMENT"} eq "1")	{ $deployment = 1; }
else	{ $deployment = 0; }

print "ARGV=@ARGV\n";

foreach (@ARGV)
{
	my ($project) = split(/:/);
	
	if (!exists($supported_builds->{"$project"}))
	{
		if ("$_" ne "clean")
		{
			print "\"$project\" is not a recognized project.\n";
		}
	}
}

foreach (@ARGV)
{
	if ($_ eq "clean")
	{
		$action = "clean";
		next;
	}
	
	($projectname, $target) = split(/:/);
			
	if (my $project = $supported_builds->{"$projectname"})
	{
		my $newdir = "$cwd/$project->{project_dir}";
		$newdir =~ s/\n//gm;
		chdir("$newdir");

		print "pwd = ", `pwd`;

		if ($target)
		{
			build_project_target($projectname, $project, $target);
		}
		else
		{
			foreach my $target (keys(%{$project->{targets}}))
			{
				build_project_target($projectname, $project, $target);
			}
		}
	}
	
	chdir($cwd);
}

sub build_project_target($$$)
{
	my ($projectname, $project, $target) = @_;
	my $cwd = `pwd`;
	chomp($cwd);
	#my $cpp_headermap_file = "$cwd/build/intermediates/$target.build/Headermaps/$target.hmap";
	my $dstroot = "/";
	my $objroot = "$cwd/build/intermediates";
	my $cmdline = "";
	my $postbuild = undef;
	my $buildstyle = undef;
	my $activebuildstyle = undef;

	if ($deployment)	{
		$buildstyle = "Deployment";
	}
	else	{
		$buildstyle = "Development";
	}	
	
	$activebuildstyle = $project->{"targets"}->{$target}->{buildstyles}->{"$buildstyle"};
	
	print "\n*** Building $projectname ($target) buildstyle ($buildstyle)\n";

	$cmdline = "pbxbuild $action -target $target -buildstyle ";

	if ($deployment)	{ $cmdline .= "\"Deployment\""; }
	else	{ $cmdline .= "\"Development\""; }

	$cmdline .= " DSTROOT=$dstroot OBJROOT=$objroot 2>&1 |";
	
	print "****** cmdline = $cmdline ******\n";

	open(PBXBUILD, $cmdline);
	while (<PBXBUILD>)      { print; }
	close(PBXBUILD);
	
	if (("$action" ne "clean") && (exists($activebuildstyle->{postbuild})))	{
		$postbuild = $activebuildstyle->{postbuild};		
		&$postbuild;
	}
}

sub PGP_postbuild()
{
	my $project = "";
	my $newdir = "";
	my $docsdir = "$cwd/../../../docs/builds/common";
	my $license = "$docsdir/License-beta.install";
	
	$project = $supported_builds->{"PGP"};
	
	my $maindir = "$cwd/$project->{project_dir}/build/PGP.app/Contents";
	$maindir =~ s/\n//gm;

	if (-e "$license")	{
		system("cp $license $maindir/Resources/English.lproj/License.txt");
	}
	
	chdir($pwd);
}
