/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CAVSelect.h,v 1.3 2002/08/06 20:09:16 dallen Exp $
____________________________________________________________________________*/
#import <PGP/pgpOptionList.h>
#import <PGP/pgpMemoryMgr.h>
#import <Cocoa/Cocoa.h>

@interface CAVSelect : NSObject
{
    IBOutlet NSButton			*mAddButton;
    IBOutlet NSButton			*mOKButton;
    IBOutlet NSButton			*mRemoveButton;
    IBOutlet NSTableView		*mAVTableView;
    IBOutlet NSWindow			*mAVWindow;
    IBOutlet NSTextField		*mCATypeField;
    IBOutlet NSMatrix			*mReqTypeMatrix;

	BOOL						mInited;
	BOOL						mLoadedNib;
	PGPError					mResultCode;
	PGPAttributeValue			*mStartAV;
	PGPAttributeValue			*mEndAV;
	PGPMemoryMgrRef				mMemMgr;
}
- (id)init;
- (id)initWithNib:(NSString*)nibFile;
- (id)initAVSelect:(PGPMemoryMgrRef)memoryMgr
		serverClass:(PGPKeyServerClass)serverClass
		requestType:(PGPUInt32)requestType
		attributesBegin:(PGPAttributeValue *)attributesBegin
		attributesEnd:(PGPAttributeValue *)attributesEnd;
- (IBAction)actionButtonPressed:(id)sender;
- (IBAction)addButtonPressed:(id)sender;
- (IBAction)removeButtonPressed:(id)sender;
- (IBAction)selectionChanged:(id)sender;
- (NSString *)attrString:(PGPAVAttribute)attr;
- (PGPAVAttribute)indexToAttribute:(PGPInt32)index;
- (PGPInt32)attributeToIndex:(PGPAVAttribute)attribute;
- (BOOL)attributeInUse:(PGPAVAttribute)attribute exclude:(int)row;
- (NSWindow *)window;
- (PGPError)resultCode;
- (void)getRequest:(PGPUInt32 *)requestType endAttributes:(PGPAttributeValue **)endAttrP;
@end

