/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CCAThread.h,v 1.2 2002/08/06 20:09:16 dallen Exp $
____________________________________________________________________________*/
#import <PGPclient/pgpClientLibCocoa.h>

enum PGPCAOp_
{
	kPGPCA_OP_RequestCert,
	kPGPCA_OP_RetrieveCert,
	kPGPCA_OP_UpdateCRL,

	PGP_ENUM_FORCE( PGPCAOp_ )
};
PGPENUM_TYPEDEF( PGPCAOp_, PGPCAOp );

@interface CCAThread : NSObject
{
	PGPCAOp				mCAOp;
	PGPContextRef		mContext;
	PGPPrefRef			mPrefRef;
	PGPtlsContextRef	mTLSContext;
	PGPKeyServerState	mLastState;
	PGPKeyServerRef		mServer;
	PGPUInt32			mCARequestType;
	PGPKeyDBObjRef		mCATargetKey;
	PGPKeyDBRef			mKeyDB;
	PGPBoolean			mCASplit;
	char				*mCAPassphrase;
	PGPByte				*mCAPassKey;
	PGPSize				mCAPassKeySize;
	BOOL				mCAPassShared;
	PGPAttributeValue	*mCAAVList;
	PGPUInt32			mCANumAVs;
	NSTextField			*mProgressStatusField;
	BOOL				*mProgressAbort;
	id					mTarget;
	SEL					mEndSelector;
}
- (id)initCAThread:(PGPContextRef)context
		prefRef:(PGPPrefRef)prefRef
		tlsContext:(PGPtlsContextRef)tlsContext
		op:(PGPCAOp)caOp
		reqType:(PGPUInt32)reqType
		keyDB:(PGPKeyDBRef)keyDB
		targetKey:(PGPKeyDBObjRef)targetKey
		passphrase:(char *)passphrase
		avList:(PGPAttributeValue *)avList		// Takes ownership of this
		numAVs:(PGPUInt32)numAVs
		status:(NSTextField *)status
		abort:(BOOL *)abortSwitch
		target:(id)target
		didEndSelector:(SEL)didEndSelector;
- (PGPError)run;
- (void)caServerThread:(id)sender;
- (PGPError)serverCallback:(PGPEvent *)event;
@end

