/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CCertInfo.h,v 1.3 2002/08/06 20:09:16 dallen Exp $
____________________________________________________________________________*/
#import <PGP/pgpKeys.h>
#import <Cocoa/Cocoa.h>

@protocol PGPCertInfo
- (PGPKeyDBRef)mainDB;
@end

@interface CCertInfo : NSObject
{
    IBOutlet NSBox			*m509Box;
    IBOutlet NSTextField	*m509IssuerField;
    IBOutlet NSTextField	*m509LastCRLField;
    IBOutlet NSTextField	*m509NameField;
    IBOutlet NSTextField	*m509NextCRLField;
    IBOutlet NSImageView	*mCertImage;
    IBOutlet NSWindow		*mCertInfoWindow;
    IBOutlet NSTextField	*mCreatedField;
    IBOutlet NSButton		*mExpiredCheckbox;
    IBOutlet NSTextField	*mExpiresField;
    IBOutlet NSButton		*mExportableCheckbox;
    IBOutlet NSBox			*mPGPBox;
    IBOutlet NSTextField	*mPGPDomainField;
    IBOutlet NSTextField	*mPGPSignerField;
    IBOutlet NSTextField	*mPGPSignerIDField;
    IBOutlet NSButton		*mRevokedCheckbox;
    IBOutlet NSButton		*mShowSignerButton;
    IBOutlet NSTextField	*mTrustDepthField;

	BOOL							mInited;
	BOOL							mLoadedNib;
	BOOL							mChanged;
	id <PGPCertInfo>				mOwnerController;
	PGPKeyDBObjRef					mCert,
									mSignerCert,
									mSignerKey;
}
+ (id)showCertInfo:(id)controller forCert:(PGPKeyDBObjRef)cert;
+ (void)closeAll:(id)sender forDB:(PGPKeyDBRef)keyDB;
- (id)init;
- (id)initWithNib:(NSString*)nibFile;
- (id)initWithController:(id)controller
		forCert:(PGPKeyDBObjRef)keyDBObj;
- (void)setInfo;
- (IBAction)showSignerAction:(id)sender;
- (PGPKeyDBObjRef)cert;
- (PGPKeyDBRef)keyDB;
- (NSWindow *)window;
@end

