/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CDurationFieldEditor.m,v 1.3 2002/08/06 20:09:16 dallen Exp $
____________________________________________________________________________*/

#import "CDurationFieldEditor.h"

@implementation CDurationFieldEditor

- (BOOL)resignFirstResponder
{
	if (![[self string] length] || ([[self string] intValue] > mMaxValue))
	{
		[self setString:@"00"];
		[self setNeedsDisplay:YES];
	}

	return [super resignFirstResponder];
}

- (void)setMaxValue:(PGPUInt32)maxValue
{
	mMaxValue = maxValue;
}

- (void)insertText:(id)string
{
	PGPUInt32			i;
	PGPUInt32			strLen = [(NSString*) string length];
	unichar				character;
	NSMutableString*	modifiedString = [[[NSMutableString alloc] init] autorelease];
	NSCharacterSet*		numericSet = [NSCharacterSet decimalDigitCharacterSet];

	for (i = 0; i < strLen; ++i)
	{
		character = [(NSString*) string characterAtIndex:i];
		
		if ([numericSet characterIsMember:character])
			[modifiedString appendFormat:@"%@", [NSString stringWithCharacters:&character length:1]];
	}

	if ([modifiedString length])
		[super insertText:modifiedString];
}

- (NSRange)selectionRangeForProposedRange:(NSRange)proposed granularity:(NSSelectionGranularity)granularity
{
	return NSMakeRange(0, [[self string] length]);
}

@end
