/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CIntegerFormatter.m,v 1.4 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/

#import "CIntegerFormatter.h"

static CIntegerFormatter*	intFormatter = nil;

@implementation CIntegerFormatter

+ (CIntegerFormatter*)intFormatter
{
	if (!intFormatter)
	{
		intFormatter = [[CIntegerFormatter alloc] init];
		[intFormatter setFormat:@"##0"];
	}
		
	return intFormatter;
}

- (BOOL)isPartialStringValid:(NSString*)string newEditingString:(NSString**)newString errorDescription:(NSString**)error
{
	unichar				charString[256];
	unichar				outString[256];
	unsigned			numValidChars = 0;
	unsigned			stringLength;
	unsigned			i;
	NSRange				charRange;
	NSCharacterSet*		numericSet = [NSCharacterSet decimalDigitCharacterSet];
	
	if (error)
		*error = nil;
	
	stringLength = [string length];
	charRange.location = 0;
	charRange.length = stringLength > (sizeof(charString) - 1) ? (sizeof(charString) - 1) : stringLength;
	
	[string getCharacters:charString range:charRange];
	
	charString[charRange.length + 1] = '\0';
	
	for (i = 0; i < charRange.length; ++i)
	{
		if ([numericSet characterIsMember:charString[i]])
		{
			outString[numValidChars] = charString[i];
			++numValidChars;
		}
	}

	if (numValidChars == charRange.length)
		return YES;
	else
	{
		*newString = [[NSString alloc] initWithCharacters:outString length:numValidChars];
		return NO;
	}
}

@end
