/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CKeyDBItem.m,v 1.8 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/
#import "CKeyDBItem.h"

@implementation CKeyDBItem

- (id)init
{
	if( !mInited )
	{
		[super init];
		mInited = YES;
		mDefault = NO;
		mChildArray = nil;
	}
    return self;
}

- (id)initWithItem:(PGPKeyDBObjRef)keyDBItem withParent:(CKeyDBItem *)parent
{
	PGPInt32	objType;
	
	[self init];
	mKeyDBItem = keyDBItem;
	mParent = parent;
	PGPGetKeyDBObjNumericProperty( keyDBItem, kPGPKeyDBObjProperty_ObjectType, &objType );
	if( objType != kPGPKeyDBObjType_Signature )
		mChildArray = [[NSMutableArray alloc] init];
	mType = objType;
	return self;
}

- (PGPKeyDBObjRef)keyDBItem
{
	return mKeyDBItem;
}

- (CKeyDBItem *)parent
{
	return mParent;
}

- (PGPKeyDBObjType)keyDBObjType
{
	return mType;
}

- (BOOL)isDefault
{
	return mDefault;
}

- (void)setDefault:(BOOL)isDefault
{
	mDefault = isDefault;
}

- (NSMutableArray *)childArray
{
	return mChildArray;
}

- (void)dealloc
{
	if( mChildArray )
		[mChildArray release];
	[super dealloc];
}

@end

