/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CKeyInfo.h,v 1.9 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/
#import <PGP/pgpKeys.h>
#import <PGP/pgpTLS.h>
#import <PGPclient/PGPOpenPrefs.h>
#import <Cocoa/Cocoa.h>
#import "CImageView.h"

@protocol PGPKeyInfo
- (void)keyInfoClosed:(id)sender withChanges:(BOOL)changed;
- (void)importKeyDB:(PGPKeyDBRef)newKeyDB confirm:(BOOL)confirm;
- (PGPPrefRef)pgpPrefRef;
- (PGPtlsContextRef)tlsContext;
@end

@interface CKeyInfo : NSObject
{
    IBOutlet NSWindow				*mKeyInfoWindow;
    IBOutlet NSPanel				*mNewSubkeyPanel;
	IBOutlet NSTabView				*mKeyInfoTabView;
	IBOutlet NSBox					*mNewSubkeyParamsBox;
    IBOutlet NSBox					*mBioFingerprintField;
	IBOutlet NSTextField			*mBioInfoField1;
	IBOutlet NSTextField			*mBioInfoField2;
	IBOutlet NSTextField			*mBioInfoField3;
	IBOutlet NSTextField			*mBioInfoField4;
    IBOutlet NSTextField			*mCiphersField;
    IBOutlet NSTextField			*mCreatedField;
    IBOutlet NSTextField			*mExpiresField;
    IBOutlet NSTextField			*mFingerprintField;
    IBOutlet NSTextField			*mNewSubkeyStartDate;
    IBOutlet NSTextField			*mNewSubkeyExpirationDate;
    IBOutlet NSTextField			*mNewSubkeySize;
    IBOutlet NSMatrix				*mNewSubkeyExpireType;
    IBOutlet NSButton				*mImplicitTrustCheckbox;
    IBOutlet NSButton				*mHexadecimalCheckbox;
	IBOutlet NSButton				*mEnabledCheckbox;
	IBOutlet NSButton				*mUpdateADKButton;
	IBOutlet NSButton				*mUpdateRevokerButton;
	IBOutlet NSButton				*mNewSubkeyButton;
	IBOutlet NSButton				*mRevokeSubkeyButton;
	IBOutlet NSButton				*mRemoveSubkeyButton;
	IBOutlet NSButton				*mNewSubkeyOKButton;
    IBOutlet NSTextField			*mKeyIDField;
    IBOutlet NSTextField			*mKeySizeField;
    IBOutlet NSTextField			*mKeyTypeField;
    IBOutlet NSButton				*mPassphraseButton;
    IBOutlet CImageView				*mPhotoIDImageView;
    IBOutlet NSSlider				*mTrustSlider;
    IBOutlet NSProgressIndicator	*mValidityIndicator;
	IBOutlet NSProgressIndicator	*mNewSubkeyGenProgress;
    IBOutlet NSTableView			*mSubkeyTableView;
    IBOutlet NSTableView			*mRevokerTableView;
    IBOutlet NSTableView			*mADKTableView;
	NSTabViewItem					*mSubkeyTabView;
	NSTabViewItem					*mRevokerTabView;
	NSTabViewItem					*mADKTabView;

	BOOL							mInited;
	BOOL							mLoadedNib;
	BOOL							mChanged;
	id <PGPKeyInfo>					mController;
	PGPKeyDBObjRef					mKey;
	PGPKeyIterRef					mKeyIter;
	PGPKeyDBRef						mKeyDB;
	PGPInt32						mNumSubkeys;
	BOOL							mLock;
	NSRect							mFingerFrame,
									mBioFrame;
	PGPTime							mSubKeyGenStartDate,
									mSubKeyGenExpireDays;
	PGPBoolean						mSplit;
	char							*mPassphrase;
	PGPByte							*mPassKey;
	PGPSize							mPassKeySize;
}

+ (id)showKeyInfo:(id)controller forKey:(PGPKeyDBObjRef)keyDBObj
		mainDB:(PGPKeyDBRef)mainKeyDB lock:(BOOL)lockdown;
+ (void)updateAllForDB:(PGPKeyDBRef)keyDB;
+ (void)closeAll:(id)sender forDB:(PGPKeyDBRef)keyDB;
- (id)init;
- (id)initWithNib:(NSString*)nibFile;
- (id)initWithController:(id)controller forKey:(PGPKeyDBObjRef)keyDBObj
		mainDB:(PGPKeyDBRef)mainKeyDB lock:(BOOL)lockdown;
- (IBAction)changePassphrasePressed:(id)sender;
- (IBAction)fingerprintDisplayChange:(id)sender;
- (IBAction)implicitTrustChanged:(id)sender;
- (IBAction)attributeChanged:(id)sender;
- (IBAction)tableButtonPressed:(id)sender;
- (void)setInfo;
- (void)adjustButtons;
- (void)updateKeyDB;
- (PGPKeyDBObjRef)updatePhotoID;
- (PGPKeyDBObjRef)keyDBItem;
- (PGPKeyDBRef)keyDB;
- (NSWindow *)window;

@end

