/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CKeyRecon.h,v 1.5 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/
#import <PGP/pgpEncode.h>
#import <PGP/pgpKeys.h>
#import <PGP/pgpTLS.h>
#import <PGPclient/pgpShare.h>
#import <PGPclient/pgpSKEP.h>
#import <PGPclient/pflPrefs.h>
#import <PGPclient/pgpClientLibCocoa.h>
#import <Cocoa/Cocoa.h>

@interface CKeyRecon : NSObject
{
    IBOutlet NSButton			*mBrowseButton;
    IBOutlet NSButton			*mCancelButton;
    IBOutlet NSTextField		*mCollectedField;
    IBOutlet NSTextField		*mKeyField;
    IBOutlet NSImageView		*mKeyImage;
    IBOutlet NSWindow			*mKeyReconWindow;
    IBOutlet NSButton			*mListenButton;
    IBOutlet NSTextField		*mNeededField;
	IBOutlet NSView				*mNetworkBoxView;
    IBOutlet NSTextField		*mNetworkHelpField;
    IBOutlet NSButton			*mOKButton;
    IBOutlet NSTableView		*mShareTableView;
    IBOutlet NSTextField		*mStatusField;
    IBOutlet NSTextField		*mStatusTitleField;

	BOOL						mInited;
	BOOL						mLoadedNib;
	PGPPrefRef					mPrefRef;
	PGPKeyDBObjRef				mKey;
	PGPKeyDBRef					mKeyDB;
	PGPtlsContextRef			mTLSContext;
	PGPByte						**mOutputPassKey;
	PGPSize						*mOutputPassKeySize;
	NSMutableArray				*mShareArray;
	NSImage						*mUserImage;
	PGPKeySetRef				mRecipientSet;
	PGPKeyID					*mKeyIDList;
	PGPUInt32					mKeyIDCount;
	BOOL						mListening;
	BOOL						mAbortSKEP;
	BOOL						mAbortImmediate;
	PGPKeyDBObjRef				mSKEPKey;
	char						*mSKEPPassphrase;
	NSString					*mAuthUserID;
	PGPShareRef					mShares;
}

- (id)init;
- (id)initWithNib:(NSString*)nibFile;
- (id)initKeyRecon:(PGPKeyDBObjRef)collectionKey
		mainDB:(PGPKeyDBRef)mainKeyDB
		tlsContext:(PGPtlsContextRef)tlsContext
		prefRef:(PGPPrefRef)prefRef
		passKey:(PGPByte **)passKey
		passKeySize:(PGPSize *)passKeySize;
- (PGPError)runKeyReconModalDialog;

- (IBAction)browsePressed:(id)sender;
- (IBAction)dialogButtonPressed:(id)sender;
- (IBAction)listenPressed:(id)sender;

- (void)addShares:(PGPShareRef *)shares from:(NSString *)userID;
- (PGPError)decryptCallback:(PGPEvent *)event;
- (PGPError)skepReconCallback:(PGPskepEvent *)event skep:(PGPskepRef)skepRef;
@end

