/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPPrefObj.h,v 1.3 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>

#import "pflPrefs.h"
#import "pflPrefTypes.h"

@interface CPGPPrefObj : NSObject
{
	PGPPrefIndex		mPrefId;
	PGPPrefType			mPrefType;
	id					mControl;
	id					mTarget;
	SEL					mSetSelector;
	SEL					mGetSelector;
	NSString*			mNotification;
	
	BOOL				mInited;
}

- (id)init;
- (id)initWithControl:(id)control prefId:(PGPPrefIndex)pref prefType:(PGPPrefType)type target:(id)target getter:(SEL)getter setter:(SEL)setter;
- (id)initWithControl:(id)control prefId:(PGPPrefIndex)pref prefType:(PGPPrefType)type target:(id)target getter:(SEL)getter setter:(SEL)setter notification:(NSString*)notification;

- (id)control;
- (void)setControl:(id)control;

- (PGPPrefIndex)prefId;
- (void)setPrefId:(PGPPrefIndex)pref;

- (PGPPrefType)prefType;
- (void)setPrefType:(PGPPrefType)type;

- (id)target;
- (void)setTarget:(id)target;

- (NSString*)notification;
- (void)setNotification:(NSString*)notification;

- (void)updateControlWithData:(void*)data size:(PGPSize)size;
- (void)retrieveControlData:(void**)data size:(PGPSize)size;

- (void)dealloc;

@end
