/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPViewer.h,v 1.8 2002/11/08 23:34:37 jeffc Exp $
____________________________________________________________________________*/
#import <PGP/PGP.h>
#import <PGPclient/pgpClientPrefs.h>
#import <PGPclient/CPGPPrefObj.h>

#import <Cocoa/Cocoa.h>

@interface CPGPViewer : NSObject
{
	PGPContextRef			mContext;
    PGPPrefRef				mPrefRef;

    IBOutlet NSButton		*mCloseButton;
    IBOutlet NSButton		*mFontSwitch;
    IBOutlet NSWindow		*mWindow;
	IBOutlet NSScrollView	*mTextScrollView;
    IBOutlet NSTextView		*mTextView;
	IBOutlet NSScrollView	*mTempestScrollView;
	IBOutlet NSImageView	*mTempestView;
	
	NSArray					*mTempestFontImageArray;
	
	BOOL					mUseTempest;
    NSString				*mOutputString;
    
    BOOL					mInited;
	BOOL					mLoadedNib;
}

- (id)init;
- (id)initWithNib:(NSString *)nibFile;
- (void)dealloc;

- (IBAction)closeViewer:(id)sender;
- (IBAction)switchView:(id)sender;

- (void)switchToTextView;
- (void)switchToTempestView;

- (PGPError)setInfo:(PGPContextRef)inContext
    prefRef:(PGPPrefRef)inPrefRef
    data:(const char *)data
    fyeo:(BOOL)fyeo;

- (void)displayIfNeeded;

- (void)setTitle:(NSString *)title;

- (NSArray *)wrapString:(NSString *)string withMaxChars:(PGPUInt32)maxChars;
- (NSImage *)imageFromPixmap:(PGPUInt32 *)pixmapData width:(int)pixmapWidth height:(int)pixmapHeight;


@end
