/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CSetupAssistant.h,v 1.7 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>

#define kPGPSetupAssistantNib					@"CSetupAssistant"
#define kPGPclSetupAssistantPageBecameActive	@"SetupAssistantPageBecameActive"

@class CSetupAssistantPage;

@interface CSetupAssistant : NSObject
{
    IBOutlet id			mWindow;
    IBOutlet id			mView;
    
    IBOutlet id			mNext;
    IBOutlet id			mBack;
    IBOutlet id			mHelp;
    IBOutlet id			mCancel;
    
    NSMutableArray*		mPages;
    
    unsigned			mCurrentPageIndex;
	unsigned			mReturnCode;
    NSView*				mCurrentView;
    id					mTarget;
	id					mPreviousDelegate;
    SEL					mEndSelector;

    BOOL				mIsRunningModal;
    BOOL				mInited;
    BOOL				mLoadedNib;
}

- (id)init;
- (id)initWithNib:(NSString*)nibFile;
- (id)initWithPages:(id)firstPage, ...;

- (void)beginSetupAssistantForTarget:(id)target didEndSelector:(SEL)endSelector isModal:(BOOL)modal;

- (NSWindow*)window;
- (NSString*)title;
- (void)setTitle:(NSString*)title;

- (BOOL)isRunningModal;

- (NSArray*)pages;
- (CSetupAssistantPage*)currentPage;
- (unsigned)currentPageIndex;
- (unsigned)returnCode;

- (void)addPage:(CSetupAssistantPage*)page;
- (void)insertPage:(CSetupAssistantPage*)page atIndex:(unsigned)index;
- (void)removePageAtIndex:(unsigned)index;
- (void)setPage:(unsigned)pageIndex;
- (void)markPageAsLastPage:(CSetupAssistantPage*)page;
- (void)markPageAtIndexAsLastPage:(unsigned)pageIndex;
- (void)unmarkPageAsLastPage:(CSetupAssistantPage*)page;
- (void)unmarkPageAtIndexAsLastPage:(unsigned)pageIndex;
- (void)gotoNextPage;
- (void)gotoPreviousPage;
- (void)callEndSelector;

- (id)nextButton;
- (id)backButton;
- (id)helpButton;
- (id)cancelButton;

- (IBAction)next:(id)sender;
- (IBAction)back:(id)sender;
- (IBAction)help:(id)sender;
- (IBAction)cancel:(id)sender;
- (IBAction)finish:(id)sender;

- (void)setupAssistantPageDidBecomeActive;
- (void)windowDidBecomeKey:(NSNotification*)notification;

- (void)dealloc;

@end
