/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CSetupAssistantPage.m,v 1.4 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/

#import "CSetupAssistantPage.h"
#import "CSetupAssistant.h"

@implementation CSetupAssistantPage

- (id)init
{
    if (!mInited)
    {
        [super init];
        
        mInited = YES;
    }
    
    return self;
}

- (id)initWithView:(NSView*)view
{
    [self setView:view];
    
    return [self init];
}

- (NSView*)view
{
    return mView;
}

- (void)setView:(NSView*)view
{
    if (view)
    {
        if (mView)
            [mView release];
        
        mView = [view retain];
    }
}

- (id)delegate
{
    return mDelegate;
}

- (void)setDelegate:(id)delegate
{
	if (mDelegate)
		[mDelegate release];
	
	mDelegate = [delegate retain];
}

- (id)setupAssistant
{
	return mSetupAssistant;
}

- (void)setSetupAssistant:(id)setupAssistant
{
	if (setupAssistant)
		mSetupAssistant = setupAssistant;
}

- (BOOL)isLastPage
{
	return mLastPage;
}

- (void)setIsLastPage:(BOOL)flag
{
	mLastPage = flag;
}

- (BOOL)assistantShouldGoToNextPage:(CSetupAssistant*)assistant
{
    if (mDelegate && [mDelegate respondsToSelector:@selector(assistantShouldGoToNextPage:)])
        return [mDelegate assistantShouldGoToNextPage:assistant];
    
    return YES;
}

- (BOOL)assistantShouldGoToPreviousPage:(CSetupAssistant*)assistant
{
	BOOL		result = YES;
	
    if (mDelegate && [mDelegate respondsToSelector:@selector(assistantShouldGoToPreviousPage:)])
        result = [mDelegate assistantShouldGoToPreviousPage:assistant];
        
    return result;
}

- (BOOL)assistantShouldFinish:(CSetupAssistant*)assistant
{
    if (mDelegate && [mDelegate respondsToSelector:@selector(assistantShouldFinish:)])
        return [mDelegate assistantShouldFinish:assistant];
        
    return YES;
}

- (void)dealloc
{
    if (mView)
        [mView release];
    
    if (mDelegate)
        [mDelegate release];

    [super dealloc];
}

@end
