/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CTableColumn.m,v 1.2 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/
#import "CTableColumn.h"

@implementation CTableColumn

- (id)init
{
	[super init];
	mCells = nil;
	mUniqueCells = NO;
    return self;
}

- (void)setUniqueCells:(BOOL)unique
{
	mUniqueCells = unique;
	if( !mUniqueCells && mCells )
	{
		[mCells release];
		mCells = nil;
	}
}

- (id)dataCellForRow:(int)row
{
	if( !mUniqueCells || ( row == -1 ) )
		return [self dataCell];
	else
	{
		if( !mCells )
			mCells = [[NSMutableArray alloc] init];
		while( [mCells count] < ( row + 1 ) )
		{
			id	cell;
			
			cell = [[self dataCell] copy];
			[mCells addObject:cell];
			[cell release];
		}
		return [mCells objectAtIndex:row];
	}
}

- (void)dealloc
{
	if( mCells )
	{
		[mCells release];
		mCells = nil;
	}
	[super dealloc];
}

@end

