/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CTraceIntruder.h,v 1.2 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/

#import <PGPclient/pgpClientLibCocoa.h>

#define kPGPclAbortTraceNotification		@"CTraceIntruder.abort"

PGPError PGPclTraceIntruder(PGPContextRef context, PGPPrefRef netPrefRef, PGPUInt32 ipAddress, id rootObject);

@protocol CTraceIntruderClient

- (void)setDNSName:(NSString*)dnsName;
- (void)setNetBTName:(NSString*)netBTName;
- (void)addTraceLog:(const char*)log title:(BOOL)title;
- (void)finish;

@end

@interface CTraceIntruder : NSObject
{
	NSConnection*		mServerConnection;	/* We hang on to this so that we can release it when our thread completes */
	PGPContextRef		mContext;
	PGPPrefRef			mNetPrefRef;
	PGPUInt32			mIPAddress;
	
	BOOL				mTraceAborted;
	BOOL				mInited;
}

- (id)init;
- (id)initWithIPAddress:(PGPUInt32)ipAddress;

- (void)setContext:(PGPContextRef)context;
- (void)setNetPrefRef:(PGPPrefRef)netPrefRef;
- (void)setServerConnection:(NSConnection*)connection;

- (void)beginTraceWithPorts:(NSArray*)ports;

- (void)abortTrace:(NSNotification*)notification;

- (void)dealloc;

@end
