/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpDialogs.h,v 1.6 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/
#ifndef Included_pgpDialogs_h	/* [ */
#define Included_pgpDialogs_h

#include <Foundation/Foundation.h>

PGP_BEGIN_C_DECLARATIONS

	static PGPUInt32
GetMacBinaryPopupInitialValue(
	PGPGetPassphraseSettings	defaultSettings,
	PGPPrefRef					clientPrefsRef);

	static void
SetMacBinaryPopupValue(
	PGPInt32					inMacBinarySetting,
	PGPPrefRef					inPrefRef);
        
	static PGPOptionListRef
TextOutputCheckboxOptionList(
	PGPContextRef 	inContext,
	PGPUInt32		inItemID,
	PGPBoolean		inChecked,
	PGPUInt32		*ioResultPtr);

	static PGPOptionListRef
DetachedSignatureCheckboxOptionList(
	PGPContextRef 	inContext,
	PGPUInt32		inItemID,
	PGPBoolean		inChecked,
	PGPUInt32		*ioResultPtr);
    
	static PGPOptionListRef
MacBinaryPopupOptionList(
	PGPContextRef 	inContext,
	PGPUInt32		inItemID,
	PGPUInt32		inInitialValue,
	PGPUInt32		*ioResultPtr);

	static PGPOptionListRef
SDACheckboxOptionList(
	PGPContextRef 	context,
	PGPUInt32		itemID,
	PGPBoolean		checked,
	PGPUInt32		*resultPtr);

	static PGPOptionListRef
ConvEncryptCheckboxOptionList(
	PGPContextRef 	context,
	PGPUInt32		itemID,
	PGPBoolean		checked,
	PGPUInt32		*resultPtr,
	PGPUInt32		showSDA,
	PGPBoolean		sdaChecked,
	PGPUInt32		*sdaResultPtr);

	static PGPOptionListRef
WipeOriginalCheckboxOptionList(
	PGPContextRef 	context,
	PGPUInt32		itemID,
	PGPBoolean		checked,
	PGPUInt32		*resultPtr);

	static PGPOptionListRef
FYEOCheckboxOptionList(
	PGPContextRef 	context,
	PGPUInt32		itemID,
	PGPBoolean		checked,
	PGPUInt32		*resultPtr);

	static PGPError
SetupAdminParams(
	PGPContextRef		context,
	PGPOptionListRef	recipientOptions,
	PGPPrefRef			clientPrefsRef,
	PGPKeyDBRef			allKeys);

	static PGPError
SetupOutgoingADK(
	PGPContextRef		context,
	PGPOptionListRef	recipientOptions,
	PGPPrefRef			clientPrefsRef,
	PGPKeyDBRef			allKeys);
    
	static PGPOptionListRef
NewCheckboxOption(
	PGPContextRef		context,
	PGPUInt32			itemID,
	NSString			*titleStr,
	NSString			*descStr,
	PGPBoolean			initialValue,
	PGPOptionListRef	subOptions,
	PGPUInt32			*resultPtr );

	static PGPOptionListRef
NewPopupListOption(
	PGPContextRef	context,
	PGPUInt32		itemID,
	NSString		*titleStr,
	NSString		*descStr,
    NSArray			*items,
	PGPBoolean		initialValue,
	PGPUInt32		*resultPtr );
    
	static PGPError
pgpClientDecryptionPassphraseDialog(
	PGPContextRef		context,
	PGPPrefRef			clientPrefsRef,				
	PGPtlsContextRef	tlsContext,
	const char			*prompt,						
	PGPKeySetRef		recipientKeys,
	const PGPKeyID		keyIDList[],		
	PGPUInt32			keyIDCount,
	PGPOptionListRef	additionalOptions,
	char				**passphrase,
	PGPKeyDBObjRef 		*decryptionKey,
	PGPKeyDBRef			*newKeys);

	static PGPError
pgpClientRecipientDialog(
	PGPContextRef			context,					
	PGPPrefRef				clientPrefsRef,				
	PGPtlsContextRef		tlsContext,
	PGPKeyDBRef				allKeys,					
	PGPUInt32				numDefaultRecipients,		
	const PGPRecipientSpec	*defaultRecipients,			
	PGPRecipientOptions		dialogOptions,				
	PGPRecipientSettings	defaultSettings,
	PGPRecipientSettings	*userSettings,			
	PGPKeyDBRef				*actualRecipients,			
	PGPKeyDBRef				*newKeys);
    
PGP_BEGIN_C_DECLARATIONS

#endif /* ] Included_pgpDialogs_h */

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
