/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpEncodeDecodeData.h,v 1.8 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/
#ifndef Included_pgpEncodeDecodeData_h	/* [ */
#define Included_pgpEncodeDecodeData_h

#include <PGP/PGP.h>
#include <PGPclient/pgpClientLibOSX.h>

PGP_BEGIN_C_DECLARATIONS

typedef struct PGPClientEncodeDecodeData
{
	PGPContextRef					context;
	PGPMemoryMgrRef					memoryMgr;
	PGPtlsContextRef				tlsContext;
	PGPKeyDBRef						allKeys;
    PGPPrefRef						prefRef;
	PGPUInt32						cursorDelay;
	PGPUInt8						frame;
	PGPUInt32						wordWrapWidth;
	PGPCipherAlgorithm *			allowedAlgorithms;
	PGPUInt32						numAlgorithms;
	PGPCipherAlgorithm				preferredAlgorithm;
	NSString						*commentString;
	PGPClientDecodeEventHandlerData	clientDecodeEventHandlerData;
	PGPByte **						decodeData;
	PGPBoolean						abort;
	PGPBoolean						fyeo;
	PGPBoolean						sigChecked;
	PGPBoolean						sigVerified;
	NSString						*beginSignedMessage;
	NSString						*endSignedMessage;
	NSString						*beginEncryptedAndSignedMessage;
	NSString						*endEncryptedAndSignedMessage;
	PGPUInt32						cacheType;
	PGPUInt32						cacheSeconds;
	PGPBoolean						cacheGlobal;
} PGPClientEncodeDecodeData;

    PGPError
PGPclInitEncodeDecodeData(
    PGPContextRef					inContext,
    PGPtlsContextRef				inTLSContext,
    PGPKeyDBRef						inKeyDBRef,
    PGPPrefRef						inPrefRef,
    PGPClientEncodeDecodeDataRef	ioData );
                
    void
PGPclUpdateEncodeDecodeData(
    PGPClientEncodeDecodeDataRef	ioData );
	                
    void
PGPclCleanupEncodeDecodeData(
    PGPClientEncodeDecodeDataRef	ioData );

PGP_BEGIN_C_DECLARATIONS

#endif /* ] Included_pgpEncodeDecodeData_h */

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
