/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPDockMenu.h,v 1.7 2002/08/06 20:09:21 dallen Exp $
____________________________________________________________________________*/

#import <PGPclient/pgpClientLibCocoa.h>
#import "PGPConsole.h"

@interface CPGPDockMenu : NSObject
{
	PGPAppController*				mAppController;
	PGPBundleManager*				mBundleManager;
	PGPInterfaceController*			mInterface;
	
	id <PGPBundle, PGPBundleDisk>	mDiskController;
	id <PGPBundle, PGPBundleKeys>	mKeysController;
	id <PGPBundle, PGPBundleMail>	mMailController;
	id <PGPBundle, PGPBundleNet>	mNetController;
	
    IBOutlet NSMenu*				mDockMenu;
	IBOutlet NSMenuItem*			mAbout;
	IBOutlet NSMenuItem*			mPreferences;
	IBOutlet NSMenuItem*			mSeparator1;
	IBOutlet NSMenuItem*			mPurgePassphrase;
	IBOutlet NSMenuItem*			mSeparator2;
	IBOutlet NSMenuItem*			mPGPdisk;
	IBOutlet NSMenuItem*			mPGPkeys;
	IBOutlet NSMenuItem*			mPGPmail;
	IBOutlet NSMenuItem*			mPGPnet;
	IBOutlet NSMenuItem*			mSeparator3;
	IBOutlet NSMenuItem*			mClipboard;
    IBOutlet NSMenuItem*			mFile;
}

+ (CPGPDockMenu*)dockMenuDelegate;

- (IBAction)about:(id)sender;
- (IBAction)decryptVerify:(id)sender;
- (IBAction)encrypt:(id)sender;
- (IBAction)encryptSign:(id)sender;
- (IBAction)sign:(id)sender;
- (IBAction)disk:(id)sender;
- (IBAction)keys:(id)sender;
- (IBAction)mail:(id)sender;
- (IBAction)net:(id)sender;
- (IBAction)preferences:(id)sender;
- (IBAction)purgePassphraseCache:(id)sender;

- (BOOL)validateMenuItem:(NSMenuItem*)item;

- (void)updateMenu;
- (void)awakeFromNib;
- (void)dealloc;

@end
