/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPKeyringSelection.h,v 1.2 2002/08/06 20:09:21 dallen Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>

@interface CPGPKeyringSelection : NSObject
{
	IBOutlet NSWindow*		mWindow;
	IBOutlet NSButton*		mCreate;
	IBOutlet NSButton*		mSelect;
	
	int						mCurrentKeyringSelection;
	BOOL					mInited;
	BOOL					mLoadedNib;
}

- (id)init;
- (void)loadNib:(NSString*)nibFile;

- (BOOL)haveKeyrings;

- (void)validateRandSeedFile;
- (BOOL)prefKeyringsValid;
- (BOOL)fileExists:(NSString*)file;
- (BOOL)haveMacOSXKeyrings;
- (BOOL)haveMacOSKeyrings;
- (BOOL)haveUnixKeyrings;
- (void)setPubKeyring:(NSString*)pubring secKeyring:(NSString*)secring;
- (void)setMacOSXKeyrings;
- (void)setMacOSKeyrings;
- (void)setUnixKeyrings;

- (void)displayKeyringSelection;

- (IBAction)createNewKeyrings:(id)sender;
- (IBAction)selectKeyrings:(id)sender;
- (IBAction)finish:(id)sender;

- (void)selectFile:(PGPPrefIndex)inIndex withExtension:(NSString*)inExtension withPrompt:(NSString*)inMessage;
- (void)openPanelDidEnd:(NSOpenPanel*)panel returnCode:(int)returnCode contextInfo:(void*)contextInfo;

- (void)dealloc;

@end
