/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: PGPBundleManager.h,v 1.13 2002/08/06 20:09:21 dallen Exp $
____________________________________________________________________________*/

#import "PGPConsole.h"

#define kPGPBundleInitialDictionarySize		10

#define kPGPBundleControllerKey				@"BundleController"
#define kPGPBundleInstanceKey				@"BundleInstance"
#define kPGPBundleInfoKey					@"BundleInfo"
#define kPGPBundleInfoPathKey				@"BundlePath"
#define kPGPBundleInfoVersionKey			@"BundleVersion"
#define kPGPBundleInfoPrincipalClassName	@"PrincipalClassName"

#define kCFBundleVersion					@"CFBundleVersion"
#define kNSPrincipalClass					@"NSPrincipalClass"

@class NSMutableDictionary, NSMutableArray, NSDictionary, NSArray, NSString;
@class PGPAppController;

@interface PGPBundleManager : NSObject
{
    PGPAppController*		myController;
    
    NSMutableDictionary*	bundles;
    /*
    Information about the loaded bundles is maintained in this dictionary.
    The contents of the dictionary will look something like the following
    once loadBundles has been called
    
    <Key:ValueType>
    
    Bundles:NSMutableDictionary
        PGPxxx.Bundle:NSMutableDictionary
            BundleInfo:NSMutableDictionary
                BundlePath:NSString
                BundleVersion:NSString
                PrincipalClassName:NSString
            BundleInstance:NSBundle
            BundleController:<Bundles:PGPxxx.Bundle:BundleInfo:PrincipalClassName>
    */
    
	NSMutableArray*			bundlePaths;

	BOOL					mLoadedBundles;
    BOOL					inited;    
}

+ (NSArray*)bundlesAtPath:(NSString*)path;
+ (NSArray*)bundlesAtPaths:(NSArray*)paths;

- (id)init;
- (id)initWithPaths:(NSArray*)paths;
- (id)initWithController:(id)controller;

- (id)controller;
- (void)setController:(id)controller;

- (void)addBundleAtPath:(NSString*)path;
- (void)setBundlePaths:(NSArray*)paths;

- (BOOL)loadBundles;
- (BOOL)loadBundlesFromPaths:(NSArray*)paths;

- (NSDictionary*)bundleInfoForBundle:(NSString*)bundle;
- (NSArray*)bundleControllers;
- (NSArray*)bundleNames;

- (id)createInstanceForBundle:(NSString*)name;
- (BOOL)releaseBundlesIfReadyToShutdown;
- (void)releaseBundleControllers;

- (NSDictionary*)bundles;
- (NSArray*)bundlePaths;
- (id)bundleByName:(NSString *)name;

- (void)dealloc;

@end
