/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: PGPPrefsAdvanced.h,v 1.7 2002/08/06 20:09:21 dallen Exp $
____________________________________________________________________________*/

#import <PGP/PGP.h>
#import <PGP/PGPPrivate.h>
#import <PGPclient/pgpClientLibCocoa.h>
#import <PGPclient/pgpClientPrefs.h>
#import <PGPclient/CPGPPrefObj.h>
#import "PGPController.h"
#import "PGPPrefsController.h"

#define kPGPPrefsAdvancedNib			@"PGPprefsAdvanced"
#define kPGPPrefsAdvancedIdentifier		NSLocalizedString(@"Advanced", @"Advanced Pref Panel")

@interface PGPPrefsAdvanced : NSObject <PGPPrefsController>
{
	id <PGPController>		mController;

	NSArray*				mIdentifiers;
	
	/* Custom view to be used when displaying our prefs */
	IBOutlet NSView*		mPrefsView;
    
    /* Cipher selection */
    IBOutlet NSPopUpButton*	mPreferredAlgorithm;
    IBOutlet NSButton*		mAES;
    IBOutlet NSButton*		mCAST;
    IBOutlet NSButton*		mTwofish;
    IBOutlet NSButton*		mTripleDES;
    IBOutlet NSButton*		mIDEA;
    
    /* Trusted model */
    IBOutlet NSButton*		mAllowMarginallyValidKeys;
    IBOutlet NSButton*		mADKWarning;
    
    /* Export format */
    IBOutlet NSButtonCell*	mCompatible;
    IBOutlet NSButtonCell*	mComplete;
	
	BOOL					mInited;
	BOOL					mLoadedNib;	
}

- (id)init;
- (id)initWithNib:(NSString*)nibFile;
- (id)initWithController:(id)controller;

- (NSArray*)identifiers;
- (id)prefsViewForIdentifier:(NSString*)identifier;

- (id)firstPrefsResponderForIdentifier:(NSString*)identifier;
- (id)lastPrefsResponderForIdentifier:(NSString*)identifier;
- (void)setupKeyViewLoopForIdentifier:(NSString*)identifier;

- (void)restorePanelPrefs:(NSString*)panelIdentifier;
- (void)restorePanelDefaults:(NSString*)panelIdentifier;
- (void)savePanelPrefs:(NSString*)panelIdentifier;

- (void)setPreferredAlgorithm:(PGPUInt32)value enabled:(BOOL)enabled;
- (void)setAllowedAlgorithms:(PGPPrefArray*)value enabled:(BOOL)enabled;
- (void)setInvalidateMarginallyValidKeys:(PGPBoolean)value enabled:(BOOL)enabled;
- (void)setWarnOnADK:(PGPBoolean)value enabled:(BOOL)enabled;
- (void)setExportKeysCompatible:(PGPBoolean)value enabled:(BOOL)enabled;

- (PGPUInt32)getPreferredAlgorithm;
- (PGPPrefArray*)getAllowedAlgorithms;
- (PGPBoolean)getInvalidateMarginallyValidKeys;
- (PGPBoolean)getWarnOnADK;
- (PGPBoolean)getExportKeysCompatible;

- (void)setCheckbox:(NSButton*)checkBox state:(BOOL)state enabled:(BOOL)enabled;
- (PGPBoolean)getCheckbox:(NSButton*)checkBox;

- (void)dealloc;

@end