/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPdiskConversion.h,v 1.5 2002/11/09 03:05:39 jeffc Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>
#import "PGPdiskCommon.h"
#import "CPGPdiskObject.h"
#import "pgpDiskEngine.h"

@protocol CPGPdiskConversionClient

- (void)completedConversionOfDisk:(NSString*)filename;
- (void)failedToConvertDisk:(NSString*)filename;

@end

@interface CPGPdiskConversion : NSObject
{
	NSString*			mOldFilename;
	NSString*			mNewFilename;
	NSData*				mPassphrase;
	NSConnection*		mConnection;

	char				mPubRingPath[PATH_MAX];
	char				mSecRingPath[PATH_MAX];
	BOOL				mInited;
}

- (id)init;

- (void)setOriginalFilename:(NSString*)filename;
- (void)setNewFilename:(NSString*)filename;
- (void)setPassphrase:(NSData*)passphrase;
- (void)setServerConnection:(NSConnection*)connection;
- (void)setPubRingPath:(char*)pubPath;
- (void)setSecRingPath:(char*)secPath;

- (void)convertDiskWithPorts:(NSArray*)ports;
- (void)abortConversion;

- (void)dealloc;

@end
