/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPdiskUserTable.h,v 1.6 2002/08/06 20:09:29 dallen Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>

#import "PGPdiskController.h"

#import <PGPui/PGPUICocoa.h>

#define kPGPdiskPubKeyUserIcon		@"pubkeyuser"
#define kPGPdiskPassphraseUserIcon	@"passphraseuser"

@class PGPdiskController;

@interface CPGPdiskUserTable : NSObject
{
	PGPdiskController*	mController;

	NSTableView*		mUserTable;
	NSImage*			mPubKeyIcon;
	NSImage*			mPassphraseIcon;

	BOOL				mEditingCell;
	BOOL				mInited;
}

- (id)init;
- (id)initWithController:(PGPdiskController*)controller;

- (id)table;
- (void)setTable:(id)table;

/* NSTableView delegate methods */
- (void)tableViewSelectionDidChange:(NSNotification*)notification;
- (BOOL)tableView:(NSTableView*)table shouldEditTableColumn:(NSTableColumn*)column row:(int)row;
- (void)tableView:(NSTableView*)table willDisplayCell:(id)cell forTableColumn:(NSTableColumn*)column row:(int)row;

/* Methods which qualify us for NSTableDataSource status */
- (int)numberOfRowsInTableView:(NSTableView*)tableView;
- (id)tableView:(NSTableView*)tableView objectValueForTableColumn:(NSTableColumn*)column row:(int)row;
- (void)tableView:(NSTableView*)tableView setObjectValue:(id)object forTableColumn:(NSTableColumn*)column row:(int)row;

@end
