/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: PGPdiskDevice.h,v 1.5 2002/08/06 20:09:34 dallen Exp $
____________________________________________________________________________*/
#pragma once

#include <IOKit/storage/IOBlockStorageDevice.h>

class PGPdiskDriver;

class PGPdiskDevice : public IOBlockStorageDevice
{
	OSDeclareDefaultStructors(PGPdiskDevice)
	
protected:
	PGPdiskDriver		*fProvider;
	
	virtual bool		attach ( IOService * provider );
	virtual void		detach ( IOService * provider );
	virtual void		stop( IOService *provider );
	virtual void		free( void );
	virtual IOReturn	message(UInt32 type, IOService * provider, void * argument);

public:
	virtual IOReturn	doAsyncReadWrite ( 	IOMemoryDescriptor *	buffer,
											UInt32					block,
											UInt32					nblks,
											IOStorageCompletion		completion );
	virtual IOReturn	doSyncReadWrite ( 	IOMemoryDescriptor *	buffer,
											UInt32					block,
											UInt32					nblks );
    virtual IOReturn	doEjectMedia ( void );
    virtual IOReturn	doFormatMedia ( UInt64 byteCapacity );
    virtual UInt32		doGetFormatCapacities ( UInt64 *	capacities,
    											UInt32		capacitiesMaxCount ) const;
    virtual IOReturn	doLockUnlockMedia ( bool doLock );
    virtual IOReturn	doSynchronizeCache ( void );
    virtual char *		getVendorString ( void );
    virtual char *		getProductString ( void );
    virtual char *		getRevisionString ( void );
    virtual char *		getAdditionalDeviceInfoString ( void );
    virtual IOReturn	reportBlockSize ( UInt64 * blockSize );
    virtual IOReturn	reportEjectability ( bool * isEjectable );
    virtual IOReturn	reportLockability ( bool * isLockable );
    virtual IOReturn	reportMediaState ( bool * mediaPresent, bool * changed );
    virtual IOReturn	reportPollRequirements ( 	bool * pollIsRequired,
    												bool * pollIsExpensive );
    virtual IOReturn	reportMaxReadTransfer ( UInt64 blockSize, UInt64 * max );
    virtual IOReturn	reportMaxValidBlock ( UInt64 * maxBlock );
    virtual IOReturn	reportMaxWriteTransfer ( UInt64 blockSize, UInt64 * max );
    virtual IOReturn	reportRemovability ( bool * isRemovable );
    virtual IOReturn	reportWriteProtection ( bool * isWriteProtected );
};

