/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CDiskInactivityImp.h,v 1.3 2002/08/06 20:09:34 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CDiskInactivityImp_h	// [
#define Included_CDiskInactivityImp_h

#include "PGPsdkDriver.h"

#include "CDiskInactivity.h"
#include "CImp.h"

_PGP_BEGIN

// Class CDiskInactivityImp

class CDiskInactivityImp : public CImp
{
	friend class CDiskInactivity;

protected:
	CComboError	CreateInactivityTimer(PGPUInt32 seconds, 
		PGPBoolean repeating, 
		CDiskInactivity::InactivityCallbackFunc pfnCallback, ULONG userVal, 
		PGPUInt32& timerID);
	CComboError	DestroyInactivityTimer(PGPUInt32 timerID);

	virtual CComboError	AttachToDriver() = 0;

protected:
	virtual CComboError	Startup() {return CComboError();}
	virtual void		Shutdown() { }

	virtual CComboError	SendInactivityCommand(
		PGPINACTIVITYSTRUCT& pgpIS) const = 0;
};

_PGP_END

#endif	// Included_CDiskInactivityImp_h
