/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CInterfaceImp.h,v 1.3 2002/08/06 20:09:34 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CInterfaceImp_h	// [
#define Included_CInterfaceImp_h

#include "CImp.h"
#include "CInterface.h"

_PGP_BEGIN

// Class CInterfaceImp

class CInterfaceImp : public CImp
{
	friend class CInterface;

protected:
	virtual void		ProcessPacket(
		DriverAPI::CCommandHeader *pPacket) const;
	virtual PGPBoolean	ProcessRawPacket(void *pMem, 
		PGPUInt32 sizeMem) const;

protected:
	virtual CComboError	Startup() {return CComboError();}
	virtual void		Shutdown() { }

	virtual CComboError	ProcessNoOp(
		DriverAPI::CCommandNoOp *pNoOp) const;

	virtual CComboError	ProcessQueryVersion(
		DriverAPI::CCommandQueryVersion *pQV) const;

	virtual CComboError	ProcessQueryMounted(
		DriverAPI::CCommandQueryMounted *pQM) const;

	virtual CComboError	ProcessQueryAllMounted(
		DriverAPI::CCommandQueryAllMounted *pQAM) const;

	virtual CComboError	ProcessNotifyUserLogoff(
		DriverAPI::CCommandNotifyUserLogoff *pNUL) const;

	virtual CComboError	ProcessSetTimeout(
		DriverAPI::CCommandSetTimeout *pST) const;

	virtual CComboError	ProcessAreDisksTimedOut(
		DriverAPI::CCommandAreDisksTimedOut *pADTO) const;

	virtual CComboError	ProcessResetTimedOut(
		DriverAPI::CCommandResetTimedOut *pRT) const;

	virtual CComboError	ProcessMount(
		DriverAPI::CCommandMount *pM) const;

	virtual CComboError	ProcessUnmount(
		DriverAPI::CCommandUnmount *pU) const;

	virtual CComboError	ProcessLockVolume(
		DriverAPI::CCommandLockVolume *pLV) const;

	virtual CComboError	ProcessUnlockVolume(
		DriverAPI::CCommandUnlockVolume *pULV) const;

	virtual CComboError	ProcessIOVolume(
		DriverAPI::CCommandIOVolume *pIOV) const;
};

_PGP_END

#endif	// Included_CInterfaceImp_h
