/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CPGPdisk.h,v 1.4 2002/08/06 20:09:34 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CPGPdisk_h	// [
#define Included_CPGPdisk_h

#include "CErrorState.h"
#include "CList.h"

#include "Crypto.h"
#include "CDriverImpFactory.h"

_PGP_BEGIN

// Class CPGPdisk

class CPGPdisk : public CErrorState, public CListableObject<CPGPdisk>
{
	NOT_COPYABLE(CPGPdisk)
	DECLARE_IMPHOST(CPGPdisk)

public:
	PGPBoolean	HasInactivityTimedOut() const;
	PGPBoolean	IsMounted() const;
	PGPBoolean	IsUnmounted() const;
	PGPBoolean	IsReadOnly() const;

	const char *	Path() const;
	const char *	Root() const;
	const char *	DeviceName() const;
	PGPUInt64		TotalBlocks() const;

	PGPBoolean	HasOpenFiles();

	void		FlipContexts();
	CComboError	ValidateContexts();
	CComboError	SetInactivityTimeout(PGPUInt32 seconds);
	void		ResetTimedOut();

	PGPUInt32	ProcessExternalIo(void *ioPacket, PGPBoolean& wasCompleted);

	CComboError	Mount(const char *path, const char *root, 
		const char *deviceName, PGPdiskEncryptionAlgorithm algorithm, 
		const void *exportedContext, PGPUInt32 sizeContext, 
		PGPUInt64 firstDataBlock, PGPUInt64 numDataBlocks, 
		const void *ioHandlerFunc, PGPUInt32 procId, 
		PGPBoolean readOnly = FALSE);
	CComboError	Unmount(PGPBoolean isForced = FALSE);

	CComboError	Read(void *buf, PGPUInt32 pos, 
		PGPUInt32 nBlocks) const;
	CComboError	Write(const void *buf, PGPUInt32 pos, 
		PGPUInt32 nBlocks);
};

_PGP_END

#endif	// ] Included_CPGPdisk_h
