/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CPGPdiskHandler.cpp,v 1.6 2002/08/06 20:09:34 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"

#include "CPGPdiskHandler.h"
#include "CPGPdiskHandlerImp.h"

_USING_PGP

// Class CPGPdiskHandler member functions

DEFINE_IMPHOST(CPGPdiskHandler, PGPdiskHandlerImp, CDriverImpFactory)

PGPBoolean
CPGPdiskHandler::IsFileAMountedPGPdisk(const char *path) const
{
	return Imp()->IsFileAMountedPGPdisk(path);
}

PGPBoolean 
CPGPdiskHandler::IsRootAMountedPGPdisk(const char *root) const
{
	return Imp()->IsRootAMountedPGPdisk(root);
}

const char * 
CPGPdiskHandler::GetDiskDevNameByPath(const char *path) const
{
	return Imp()->GetDiskDevNameByPath(path);
}

const char * 
CPGPdiskHandler::GetDiskDevNameByRoot(const char *root) const
{
	return Imp()->GetDiskDevNameByRoot(root);
}

PGPUInt32 
CPGPdiskHandler::NumPGPdisks() const
{
	return Imp()->NumPGPdisks();
}

CComboError 
CPGPdiskHandler::ExportPGPdiskInfo(
	PGPdiskInfo	*pInfoArray, 
	PGPUInt32	numElems, 
	PGPUInt32	&elemsFilled)
{
	return Imp()->ExportPGPdiskInfo(pInfoArray, numElems, elemsFilled);
}

void 
CPGPdiskHandler::TurnOnUnmountAllMode()
{
	Imp()->TurnOnUnmountAllMode();
}

CComboError 
CPGPdiskHandler::SetInactivityTimeout(const char *root, PGPUInt32 seconds)
{
	return Imp()->SetInactivityTimeout(root, seconds);
}

PGPBoolean 
CPGPdiskHandler::AreDisksTimedOut()
{
	return Imp()->AreDisksTimedOut();
}

void 
CPGPdiskHandler::ResetTimedOutDisk(const char *root)
{
	Imp()->ResetTimedOutDisk(root);
}

CComboError 
CPGPdiskHandler::MountPGPdisk(
	const char	*path, 
	const char	*root, 
	PGPdiskEncryptionAlgorithm	algorithm, 
	const void	*exportedContext, 
	PGPUInt32	sizeContext, 
	PGPUInt64	firstDataBlock, 
	PGPUInt64	numDataBlocks, 
	char		*deviceName, 
	PGPBoolean	readOnly)
{
	return Imp()->MountPGPdisk(path, root, algorithm, exportedContext, 
		sizeContext, firstDataBlock, numDataBlocks, deviceName, readOnly);
}

CComboError 
CPGPdiskHandler::UnmountPGPdisk(const char *root, PGPBoolean isForced)
{
	return Imp()->UnmountPGPdisk(root, isForced);
}

CComboError 
CPGPdiskHandler::UnmountAllPGPdisks(PGPBoolean isForced)
{
	return Imp()->UnmountAllPGPdisks(isForced);
}

CComboError 
CPGPdiskHandler::Startup()
{
	return Imp()->Startup();
}

void 
CPGPdiskHandler::Shutdown()
{
	Imp()->Shutdown();
}
