/*____________________________________________________________________________
        Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: pgpDiskAES.h,v 1.2 2002/08/06 20:09:35 dallen Exp $
____________________________________________________________________________*/
#ifndef Included_pgpDiskAES_h
#define Included_pgpDiskAES_h

#include "pgpBase.h"

/* From cipherAES256, 4 byte rounds, Scheduled key, 1 byte enc/dec */
#define kMaxAESContextSize		(4+16*(256/32 + 7)+1)


void
aes128Key(
	void *			priv,
	void const *	keymaterial);

void
aes192Key(
	void *			priv,
	void const *	keymaterial);

void
aes256Key(
	void *			priv,
	void const *	keymaterial);

void
aesEncrypt(
	void *			priv,
	void const *	in,
	void *			out);

void
aesDecrypt(
	void *			priv,
	void const *	in,
	void *			out);

void
aesEncryptCFBdbl(
	void *			priv,
	PGPUInt32		ivs[],
	void const *	in,
	void *			out,
	PGPUInt32		len );

void
aesDecryptCFBdbl(
	void *			priv,
	PGPUInt32		ivs[],
	void const *	in,
	void *			out,
	PGPUInt32		len );

#endif /* !Included_pgpDiskAES_h */
