/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CDriverComm.cpp,v 1.4 2002/08/06 20:09:36 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"

#include "CString.h"
#include "CDriverComm.h"
#include "CDriverCommImp.h"

_USING_PGP

// Class CDriverComm member functions

DEFINE_IMPHOST(CDriverComm, DriverCommImp, CEngineImpFactory)

PGPBoolean 
CDriverComm::IsDriverOpened() const
{
	return Imp()->IsDriverOpened();
}

void 
CDriverComm::QueryVersion(PGPUInt32& driverApiVersion) const
{
	Imp()->QueryVersion(driverApiVersion);
}

void 
CDriverComm::QueryMountedPath(const char *path, PGPBoolean& isMounted) const
{
	Imp()->QueryMountedPath(path, isMounted);
}

void 
CDriverComm::QueryMountedRoot(const char *root, PGPBoolean& isMounted) const
{
	Imp()->QueryMountedRoot(root, isMounted);
}

void 
CDriverComm::QueryAllMounted(
	PGPdiskInfo	*pInfoArray, 
	PGPUInt32	elemsArray, 
	PGPUInt32&	elemsFilled) const
{
	Imp()->QueryAllMounted(pInfoArray, elemsArray, elemsFilled);
}

void 
CDriverComm::NotifyUserLogoff() const
{
	Imp()->NotifyUserLogoff();
}

void 
CDriverComm::SetTimeout(const char *root, PGPUInt32 seconds) const
{
	Imp()->SetTimeout(root, seconds);
}

PGPBoolean 
CDriverComm::AreDisksTimedOut() const
{
	return Imp()->AreDisksTimedOut();
}

void 
CDriverComm::ResetTimedOutDisk(const char *root) const
{
	Imp()->ResetTimedOutDisk(root);
}

void 
CDriverComm::Mount(
	const char	*path, 
	const char	*root, 
	PGPdiskEncryptionAlgorithm	algorithm, 
	const void	*exportedContext, 
	PGPUInt32	sizeContext, 
	PGPUInt64	firstDataBlock, 
	PGPUInt64	numDataBlocks, 
	CString&	deviceName, 
	PGPBoolean	readOnly) const
{
	Imp()->Mount(path, root, algorithm, exportedContext, sizeContext, 
		firstDataBlock, numDataBlocks, deviceName, readOnly);
}

void 
CDriverComm::Unmount(const char *root, PGPBoolean isForced) const
{
	Imp()->Unmount(root, isForced);
}

PGPUInt32 
CDriverComm::LockVolume(const char *root, PGPBoolean forFormat) const
{
	return Imp()->LockVolume(root, forFormat);
}

void 
CDriverComm::UnlockVolume(PGPUInt32 handle) const
{
	Imp()->UnlockVolume(handle);
}

void 
CDriverComm::IOVolume(
	PGPUInt32	handle, 
	PGPBoolean	trueIfRead, 
	void		*buffer, 
	PGPUInt64	blockPos, 
	PGPUInt32	blocksLength) const
{
	Imp()->IOVolume(handle, trueIfRead, buffer, blockPos, blocksLength);
}

void 
CDriverComm::Startup()
{
	Imp()->Startup();
}

void 
CDriverComm::Shutdown()
{
	Imp()->Shutdown();
}
