/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CDriverCommImp.h,v 1.4 2002/08/06 20:09:36 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CDriverCommImp_h	// [
#define Included_CDriverCommImp_h

#include "CImp.h"
#include "CString.h"

#include "DriverAPI.h"
#include "CDriverComm.h"

_PGP_BEGIN

// Class CDriverCommImp

class CDriverCommImp : public CImp
{
	friend class CDriverComm;

protected:
	CDriverCommImp() : mIsDriverOpened(FALSE) { }
	PGPBoolean	IsDriverOpened() const {return mIsDriverOpened;}

protected:
	PGPBoolean	mIsDriverOpened;

	virtual void	Startup();
	virtual void	Shutdown();

	virtual void	OpenDriver() = 0;
	virtual void	CloseDriver() = 0;

	virtual void	SendPacket(DriverAPI::CCommandHeader *pPacket, 
		PGPUInt32 size) const = 0;

	virtual void	QueryVersion(PGPUInt32& driverApiVersion) const;
	virtual void	QueryMountedPath(const char *path, 
		PGPBoolean& isMounted) const;
	virtual void	QueryMountedRoot(const char *root, 
		PGPBoolean& isMounted) const;
	virtual void	QueryAllMounted(PGPdiskInfo *pInfoArray, 
		PGPUInt32 elemsArray, PGPUInt32& elemsFilled) const;

	virtual void	NotifyUserLogoff() const;

	virtual void		SetTimeout(const char *root, PGPUInt32 seconds) const;
	virtual PGPBoolean	AreDisksTimedOut() const;
	virtual void		ResetTimedOutDisk(const char *root) const;

	virtual void	Mount(const char *path, const char *root, 
		PGPdiskEncryptionAlgorithm algorithm, const void *exportedContext, 
		PGPUInt32 sizeContext, PGPUInt64 firstDataBlock, 
		PGPUInt64 numDataBlocks, CString& deviceName, 
		PGPBoolean readOnly = FALSE) const;
	virtual void	Unmount(const char *root, PGPBoolean isForced) const;

	virtual PGPUInt32	LockVolume(const char *root, 
		PGPBoolean forFormat) const;
	virtual void		UnlockVolume(PGPUInt32 handle) const;
	virtual void		IOVolume(PGPUInt32 handle, PGPBoolean trueIfRead, 
		void *buffer, PGPUInt64 blockPos, PGPUInt32 blocksLength) const;
};

_PGP_END

#endif	// Included_CDriverCommImp_h
