/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CKeySearch.h,v 1.13 2002/08/28 03:34:27 dallen Exp $
____________________________________________________________________________*/
#import <PGP/pgpKeys.h>
#import <PGPclient/pgpKeyServerPrefs.h>
#import <PGPclient/PGPOpenPrefs.h>
#import "CPGPkeysView.h"

enum
{
	kKeySearchType_UserID		= 0,
	kKeySearchType_KeyID,
	kKeySearchType_KeyType,
	kKeySearchType_Creation,
	kKeySearchType_Expiration,
	kKeySearchType_Status,
	kKeySearchType_Size,
	kKeySearchTypeCount
};

enum PGPKeySearchOp_
{
	kKeySearchOp_Search		= 0,
	kKeySearchOp_Delete,
	kKeySearchOp_Disable
};
PGPENUM_TYPEDEF( PGPKeySearchOp_, PGPKeySearchOp );

@protocol PGPKeySearch
- (void)sign:(CPGPkeysView *)keysView forArray:(NSMutableArray *)userIDArray;
- (void)split:(id)keysView forKey:(PGPKeyDBObjRef)splitKey;
- (PGPKeyDBRef)mainDB;
- (void)keySearchClosed;
@end

@interface CKeySearch : NSObject <PGPKeysView>
{
	IBOutlet NSWindow				*mSearchWindow;
	IBOutlet NSButton				*mSearchButton;
	IBOutlet NSButton				*mClearButton;
	IBOutlet NSView					*mChoicesView;
	IBOutlet NSBox					*mCriteriaBox;
	IBOutlet NSButton				*mFewerChoicesButton;
	IBOutlet NSButton				*mMoreChoicesButton;
	IBOutlet NSView					*mKeyView;
	IBOutlet NSView					*mStatusView;
	IBOutlet NSButton				*mPendingCheckbox;
	IBOutlet NSPopUpButton			*mSourcePopup;
	IBOutlet NSTextField			*mStatusField;
	IBOutlet NSProgressIndicator	*mSearchProgress;
	
	id <PGPKeySearch>				mController;
	BOOL							mInited;
	BOOL							mLoadedNib;
	BOOL							mRunning;
	PGPContextRef					mPGPContext;
	PGPtlsContextRef				mTLSContext;
	PGPPrefRef						mPrefRef;
	CPGPkeysView					*mPGPkeysView;
	PGPKeyServerEntry				*mServers;
	PGPUInt32						mNumServers;
	NSMutableArray					*mSearchPanelArray;
	PGPUInt32						mLastSearchType;
	PGPKeyServerRef					mCurrentServer;
	PGPFilterRef					mServerFilter;
	PGPKeyServerState				mLastState;
	PGPKeySetRef					mActionKeySet;
	PGPKeySearchOp					mOp;
}
- (id)init;
- (id)initWithNib:(NSString*)nibFile;
- (id)initWithController:(id)controller;
- (IBAction)moreChoicesAction:(id)sender;
- (IBAction)fewerChoicesAction:(id)sender;
- (IBAction)searchAction:(id)sender;
- (IBAction)clearAction:(id)sender;
- (void)loadSourcePopup;
- (void)addSearchPanel;
- (void)removeSearchPanel;
- (void)fixKeyViews:(BOOL)selectLast;

- (PGPKeyDBRef)mainDB;
- (NSWindow *)window;
- (CPGPkeysView *)pgpKeysView;
- (PGPContextRef)pgpContext;
- (PGPtlsContextRef)tlsContext;
- (PGPPrefRef)pgpPrefRef;
- (PGPError)serverCallback:(PGPEvent *)event;
- (void)serverCommand:(int)command;
- (void)serversUpdated;

@end

