
#import "CKeyServerUpdate.h"

#define kCKeyServerUpdateNib		@"CKeyServerUpdate.nib"

static CKeyServerUpdate*	sSharedInstance = nil;

@implementation CKeyServerUpdate

+ (id)sharedInstance
{
	if (!sSharedInstance)
		sSharedInstance = [[CKeyServerUpdate alloc] init];
	
	return sSharedInstance;
}

- (id)init
{
	if (!mInited)
	{
		[super init];
		
		mReturnCode = kPGPError_NoErr;
		
		mInited = YES;
	}
	
	if (!mLoadedNib)
		[self loadNib];
	
	return self;
}

- (void)loadNib
{
	[NSBundle loadNibNamed:kCKeyServerUpdateNib owner:self];
	
	[mProgress setUsesThreadedAnimation:YES];
	
	mLoadedNib = YES;
}

- (void)close
{
	mReturnCode = kPGPError_NoErr;
	
	[mWindow close];
}

- (NSWindow*)window
{
	return mWindow;
}

- (NSTextField*)server
{
	return mServer;
}

- (NSTextField*)status
{
	return mStatus;
}

- (NSProgressIndicator*)progress
{
	return mProgress;
}

- (NSButton*)cancel
{
	return mCancel;
}

- (PGPError)returnCode
{
	return mReturnCode;
}

- (PGPKeyServerRef)keyserver
{
	return mKeyserver;
}

- (void)setKeyserver:(PGPKeyServerRef)keyserver
{
	mKeyserver = keyserver;
}

- (IBAction)cancel:(id)sender
{
	mReturnCode = kPGPError_UserAbort;
	
	if (PGPKeyServerRefIsValid(mKeyserver))
		PGPCancelKeyServerCall(mKeyserver);
	
	mKeyserver = kInvalidPGPKeyServerRef;
}

- (void)dealloc
{
	if (self == sSharedInstance)
		sSharedInstance = nil;
	
	[super dealloc];
}

@end
