/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CKeyring.h,v 1.2 2002/08/06 20:09:45 dallen Exp $
____________________________________________________________________________*/
#import <PGP/pgpKeys.h>
#import <PGPclient/PGPOpenPrefs.h>
#import "CPGPkeysView.h"
#import "PGPkeysController.h"

@class CKeyring;

@interface CKeyring : NSObject <PGPKeysView>
{
	IBOutlet NSWindow				*mKeyringWindow;
	IBOutlet NSView					*mViewBox;
	
	PGPkeysController				*mController;
	BOOL							mInited;
	BOOL							mLoadedNib;
	PGPContextRef					mPGPContext;
	PGPtlsContextRef				mTLSContext;
	PGPPrefRef						mPrefRef;
	CPGPkeysView					*mPGPkeysView;
}
- (id)init;
- (id)initWithNib:(NSString*)nibFile;
- (id)initWithController:(id)controller;
- (void)loadKeyring:(NSString *)docFile;

- (PGPKeyDBRef)mainDB;
- (NSWindow *)window;
- (CPGPkeysView *)pgpKeysView;
- (PGPContextRef)pgpContext;
- (PGPtlsContextRef)tlsContext;
- (PGPPrefRef)pgpPrefRef;
@end

