/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPVerification.m,v 1.7 2002/08/06 20:09:48 dallen Exp $
____________________________________________________________________________*/

#import "CPGPVerification.h"

@implementation CPGPVerification

- (id)init
{
    self = [super init];
    [self setName:@"" validity:NO];
    [self setSigner:@""];
    [self setValidity:nil validity:NO];
    [self setSigned:nil];
    [self setVerified:nil];
    
    return( self );
}

- (void)dealloc
{
    [mFileName release];
    [mSigner release];
    [mSigned release];
    [mVerified release];
    [super dealloc];
}

- (NSString *)getName
{
    return( mFileName );
}

- (void)setName:(NSString *)value validity:(BOOL)valid
{
    [mFileName autorelease];
    mFileName = [value copy];
    mSigValid = valid;
}

- (NSString *)getSigner
{
    return( mSigner );
}

- (void)setSigner:(NSString *)value
{
    [mSigner autorelease];
    mSigner = [value copy];
}

- (NSImage *)getValidity
{
    return( mValidity );
}

- (void)setValidity:(NSImage *)value validity:(BOOL)valid
{
    [mValidity autorelease];
    mValidity = [value copy];
    mKeyValid = valid;
}

- (NSCalendarDate *)getSigned
{
    return( mSigned );
}

- (void)setSigned:(NSCalendarDate *)value
{
    [mSigned autorelease];
    mSigned = [value copy];
}

- (NSCalendarDate *)getVerified
{
    return( mVerified );
}

- (void)setVerified:(NSCalendarDate *)value
{
    [mVerified autorelease];
    mVerified = [value copy];
}

- (BOOL)isKeyValid
{
    return( mKeyValid );
}

- (BOOL)isSigValid
{
    return( mSigValid );
}

@end

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/