/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPmailPreferences.h,v 1.11 2002/08/06 20:09:48 dallen Exp $
____________________________________________________________________________*/
#ifndef Included_CPGPmailPreferences_h	/* [ */
#define Included_CPGPmailPreferences_h

#import <Cocoa/Cocoa.h>
#import <PGP/PGP.h>
#import <PGP/PGPPrivate.h>
#import <PGPclient/pgpClientLibCocoa.h>
#import <PGPclient/pgpClientPrefs.h>
#import <PGPclient/CPGPPrefObj.h>
#import "PGPPrefsController.h"
#import "CPGPmailController.h"

#define kPGPmailPreferencesNib			@"CPGPmailPreferences"
#define kPGPmailPrefsIdentifier			LSPM(@"Email", @"PGPmail Pref Panel")

@class NSDictionary, NSMutableDictionary;

@interface CPGPmailPreferences : NSObject <PGPPrefsController>
{
	CPGPmailController*		mMailController;

    NSMutableDictionary*	mPrefsDictionary;

	NSArray*				identifiers;

    IBOutlet NSButton		*mAutoDecryptCheckButton;
    IBOutlet NSView			*mEmailPrefsView;
    IBOutlet NSButton		*mEncryptNewCheckButton;
    IBOutlet NSButton		*mPGPMIMECheckButton;
    IBOutlet NSButton		*mSignNewCheckButton;
    IBOutlet NSButton		*mWordWrapCheckButton;
    IBOutlet NSTextField	*mColumnWidthField;
    
    IBOutlet NSImageView	*mEmailIcon;
    IBOutlet NSTextField	*mNoteMessage;
    IBOutlet NSBox			*mContainerBox;
    
    BOOL					mInited;
    BOOL					mLoadedNib;
}

- (id)init;
- (id)initWithNib:(NSString*)nibFile;
- (id)initWithController:(id)controller;

- (id)controller;
- (NSArray*)identifiers;
- (id)prefsViewForIdentifier:(NSString*)identifier;

- (id)firstPrefsResponderForIdentifier:(NSString*)identifier;
- (id)lastPrefsResponderForIdentifier:(NSString*)identifier;
- (void)setupKeyViewLoopForIdentifier:(NSString*)identifier;

- (void)restorePanelPrefs:(NSString*)panelIdentifier;
- (void)restorePanelDefaults:(NSString*)panelIdentifier;
- (void)savePanelPrefs:(NSString*)panelIdentifier;

- (void)setUsePGPMIME:(PGPBoolean)value enabled:(BOOL)enabled;
- (void)setEncryptByDefault:(PGPBoolean)value enabled:(BOOL)enabled;
- (void)setSignByDefault:(PGPBoolean)value enabled:(BOOL)enabled;
- (void)setAutoDecryptVerify:(PGPBoolean)value enabled:(BOOL)enabled;
- (void)setWordWrapEnabled:(PGPBoolean)value enabled:(BOOL)enabled;
- (void)setWordWrapWidth:(PGPUInt32)value enabled:(BOOL)enabled;

- (PGPBoolean)getUsePGPMIME;
- (PGPBoolean)getEncryptByDefault;
- (PGPBoolean)getSignByDefault;
- (PGPBoolean)getAutoDecryptVerify;
- (PGPBoolean)getWordWrapEnabled;
- (PGPUInt32)getWordWrapWidth;

- (void)setCheckbox:(NSButton*)checkBox state:(BOOL)state enabled:(BOOL)enabled;
- (PGPBoolean)getCheckbox:(NSButton*)checkBox;

- (IBAction)wordWrap:(id)sender;

@end

#endif /* ] Included_CPGPmailPreferences_h */

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/