/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation.
    All rights reserved.

    $Id: CPGPmailMutableData.m,v 1.11 2002/08/13 21:38:24 wmalik Exp $
____________________________________________________________________________*/

#import "CPGPmailMutableData.h"
#import "CPGPmailData.h"
#import <Foundation/NSException.h>
#import <Foundation/NSString.h>
#import "PGPmailViewerCommon.h"
#import "NSDataMessage.h"

#define kPGPmailFrom				@"From "
#define kPGPmailNlCrFrom			@"\r\nFrom "

@implementation NSMutableData( PGPmail )

- (void)pgpStandardizeDataForSigning
{
    [self setData:[self pgpConvertEndOfLines]];
}

- (void)pgpStandardizeDataForVerifying
{
    [self setData:[self pgpConvertEndOfLines]];
}

- (BOOL)pgpIsQuotedPrintableNeeded:(BOOL)inAlreadyUsedQuotedPrintable
{
    BOOL		theResult = NO;
    
    if( [self pgpContainsNonASCIICharacters] )
    {
        NSParameterAssert( inAlreadyUsedQuotedPrintable == NO );
        theResult = YES;
    }
    else
    {
        NSString 	*theString = [[NSString alloc] initWithData:self 
                encoding:NSASCIIStringEncoding];
        
        theResult = ( [theString hasPrefix:kPGPmailFrom] ||
                      [theString rangeOfString:kPGPmailNlCrFrom
                      options:NSLiteralSearch].length > 0 );
        
        [theString release];
    }
    
    if( theResult )
        theResult = NO;
    
    return theResult && !inAlreadyUsedQuotedPrintable;
}

@end
