/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation.
    All rights reserved.

    $Id: ComposeBackEnd.h,v 1.2 2002/08/24 01:32:31 wmalik Exp $
____________________________________________________________________________*/

#import <Foundation/NSObject.h>

@class Message;
@class NSMutableDictionary;
@class NSMutableArray;
@class NSAttributedString;
@class NSUndoManager;
@class ActivityMonitor;
@class MailboxUid;

@interface ComposeBackEnd:NSObject
{
    id _delegate;
    Message *_originalMessage;
    NSMutableDictionary *_cleanHeaders;
    NSMutableArray *_extraRecipients;
    NSAttributedString *_messageContents;
    NSString *_attachmentDirectory;
    NSString *_encodingType;
    NSUndoManager *_undoManager;
    ActivityMonitor *_backgroundSaveActivity;
    MailboxUid *_lastDraftsMailboxUid;
    NSString *_lastMessageId;
    //struct ? _flags;
    long _flags;
}

- (void)dealloc;
- init;
- delegate;
- (void)setDelegate:fp12;
- (char)hasChanges;
- (void)setHasChanges:(char)fp12;
- undoManager;
- (void)setUndoManager:fp12;
- (void)setType:(int)fp12;
- (int)type;
- (void)setIsUndeliverable:(char)fp12;
- (char)isUndeliverable;
- originalMessage;
- (void)setOriginalMessage:fp12;
- attachmentDirectory;
- message;
- account;
- deliveryAccount;
- sender;
- (void)setSender:fp12;
- subject;
- (void)setSubject:fp12;
- messageID;
- (void)setShowAllHeaders:(char)fp12;
- (void)setEncodingType:fp12;
- encodingType;
- defaultTextAttributes;
- messageContents;
- messageContentsForInitialText:fp12;
- (void)setMessageContents:fp12;
- signatureName;
- signature;
- (void)setSignature:fp12;
- (void)addHeaders:fp12;
- addressListForHeader:fp12;
- (void)setAddressList:fp12 forHeader:fp16;
- (void)insertAddress:fp12 forHeader:fp16 atIndex:(unsigned int)fp20;
- (void)removeAddressForHeader:fp12 atIndex:(unsigned int)fp16;
- (char)isAddressHeaderKey:fp12;
- (char)deliverMessage;
- (char)isDeliveringMessage;
- (void)_synchronouslyAppendMessageToOutbox:fp12;
- (void)_backgroundAppendEnded:fp12;
- (void)_backgroundSaveEnded:fp12;
- (char)saveMessage;
- (char)isSavingMessage;
- (void)removeLastDraft;
- lastMessageID;
@end

@interface ComposeBackEnd(Internal)
- (void)_textStorageChanged:fp12;
- (void)_setupDefaultRecipients:fp12;
- (void)_saveMessageSynchronously:fp12;
- (void)saveRecipients;
@end

@interface ComposeBackEnd(ScriptingSupport)
+ _messageEditorForComposeBackEnd:fp12 window:(id *)fp16;
- (char)isVisible;
- (void)setIsVisible:(char)fp12;
- appleScriptSender;
- (void)setAppleScriptSender:fp12;
- appleScriptSubject;
- (void)setAppleScriptSubject:fp12;
- content;
- (void)setContent:fp12;
- messageSignature;
- (void)setMessageSignature:fp12;
- (void)_addRecipientsForKey:fp12 toArray:fp16;
- recipients;
- toRecipients;
- ccRecipients;
- bccRecipients;
- (void)insertRecipient:fp12 atIndex:(unsigned int)fp16 inHeaderWithKey:fp20;
- (void)insertInToRecipients:fp12 atIndex:(unsigned int)fp16;
- (void)insertInToRecipients:fp12;
- (void)insertInCcRecipients:fp12 atIndex:(unsigned int)fp16;
- (void)insertInCcRecipients:fp12;
- (void)insertInBccRecipients:fp12 atIndex:(unsigned int)fp16;
- (void)insertInBccRecipients:fp12;
- (void)removeFromToRecipientsAtIndex:(unsigned int)fp12;
- (void)removeFromCcRecipientsAtIndex:(unsigned int)fp12;
- (void)removeFromBccRecipientsAtIndex:(unsigned int)fp12;
- (void)replaceFormattedAddress:fp12 withAddress:fp16 forKey:fp20;
- handleSaveMessageCommand:fp12;
- handleSendMessageCommand:fp12;
- uniqueID;
- objectSpecifier;
@end
