/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation.
    All rights reserved.

    $Id: Message.h,v 1.2 2002/08/24 01:32:31 wmalik Exp $
____________________________________________________________________________*/

#import <Foundation/NSObject.h>

@class MessageHeaders;
@class MessageStore;

@interface Message:NSObject
{
    MessageStore *_store;
    MessageHeaders *_headers;
    unsigned int _messageFlags;
    //struct ? _flags;
    long _flags;
    unsigned int _preferredEncoding;
}

+ verboseVersion;
+ frameworkVersion;
+ (void)setUserAgent:fp12;
+ userAgent;
+ messageWithRFC822Data:fp12;
+ _filenameFromSubject:fp12 inDirectory:fp16 ofType:fp20;
+ makeUniqueAttachmentNamed:fp12 inDirectory:fp16;
+ makeUniqueAttachmentNamed:fp12 withExtension:fp16 inDirectory:fp20;
- description;
- init;
- copyWithZone:(struct _NSZone *)fp12;
- messageStore;
- (void)setMessageStore:fp12;
- retainedHeaders;
- headers;
- mutableHeaders;
- (void)setHeaders:fp12;
- (unsigned int)messageFlags;
- (void)setMessageFlags:(unsigned int)fp12;
- messageBody;
- messageBodyIfAvailable;
- messageDataIncludingFromSpace:(char)fp12;
- (char)colorHasBeenEvaluated;
- color;
- (void)setColor:fp12;
- (void)setColorHasBeenEvaluated:(char)fp12;
- (void)dealloc;
- (unsigned int)messageSize;
- (void)flushCachedData;
- attributedString;
- preferredEmailAddressToReplyWith;
- displayTypes;
- messageID;
- (int)compareByNumberWithMessage:fp12;
- (char)isMessageContentsLocallyAvailable;
- headersForIndexing;
- stringForIndexing;
- (unsigned int)numberOfAttachments;
- (int)junkMailLevel;
- (unsigned int)preferredEncoding;
- (void)setPreferredEncoding:(unsigned int)fp12;
- rawSourceFromHeaders:fp12 body:fp16;
@end

@interface Message(ScriptingSupport)
- objectSpecifier;
- (char)isRead;
- (void)setIsRead:(char)fp12;
- (char)isJunk;
- (void)setIsJunk:(char)fp12;
- (char)isDeleted;
- (void)setIsDeleted:(char)fp12;
- subject;
- sender;
- replyTo;
- dateSent;
- dateReceived;
- scriptedMessageSize;
- content;
- (void)_addRecipientsForKey:fp12 toArray:fp16;
- recipients;
- toRecipients;
- ccRecipients;
- bccRecipients;
- container;
- (void)setContainer:fp12;
- messageIDHeader;
- rawSource;
- allHeaders;
@end

@interface Message(MailViewerAdditions)
- htmlNodeForHeaderWithTitle:fp12 value:fp16;
- spacerRowWithHeight:fp12 columnSpan:fp16 backgroundColor:fp20;
- sideBorderCell;
- sideSpacer;
- topLevelTableWithHeaderParent:(id *)fp12 imageParent:(id *)fp16 topMargin:(int)fp20;
- htmlTreeForHeaders:(int)fp12 withTopMargin:(int)fp16;
@end

@interface Message(Chat)
+ chatURLForEmails:fp12;
@end
