/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation.
    All rights reserved.

    $Id: MimePart.h,v 1.1 2002/08/21 03:17:17 wmalik Exp $
____________________________________________________________________________*/

#import <Foundation/NSObject.h>
#import <Foundation/NSString.h>
#import <Foundation/NSMapTable.h>

@class NSMutableArray;
@class NSMutableData;
@class NSMutableDictionary;
@class MessageHeaders;

@interface MimePart:NSObject <NSCopying>
{
    NSString *_type;
    NSString *_subtype;
    NSMutableDictionary *_bodyParameters;
    NSString *_contentTransferEncoding;
    NSMutableDictionary *_otherIvars;
    struct _NSRange _range;
    id _parentOrBody;
    MimePart *_nextPart;
}

+ (void)initialize;
- (void)dealloc;
- init;
- type;
- (void)setType:fp12;
- subtype;
- (void)setSubtype:fp12;
- bodyParameterForKey:fp12;
- (void)setBodyParameter:fp12 forKey:fp16;
- bodyParameterKeys;
- contentTransferEncoding;
- (void)setContentTransferEncoding:fp12;
- disposition;
- (void)setDisposition:fp12;
- dispositionParameterForKey:fp12;
- (void)setDispositionParameter:fp12 forKey:fp16;
- dispositionParameterKeys;
- contentDescription;
- (void)setContentDescription:fp12;
- contentID;
- (void)setContentID:fp12;
- languages;
- (void)setLanguages:fp12;
- parentPart;
- firstChildPart;
- nextSiblingPart;
- subparts;
- subpartAtIndex:(int)fp12;
- (void)setSubparts:fp12;
- (void)addSubpart:fp12;
- (struct _NSRange)range;
- (void)setRange:(struct _NSRange)fp12;
- bodyData;
- mimeBody;
- (void)setMimeBody:fp12;
- description;
- attachmentFilename;
- (char)hasCachedDataInStore;
- (unsigned int)numberOfAttachments;
- (unsigned int)textEncoding;
- (unsigned int)approximateRawSize;
- (char)isAttachment;
- (char)isRich;
- attributedString;
- htmlDocument;
- fileWrapper;
- stringForIndexing;
- startPart;
- (int)numberOfAlternatives;
- alternativeAtIndex:(int)fp12;
- copyWithZone:(struct _NSZone *)fp12;
@end

@interface MimePart(DecodingSupport)
- _fullMimeTypeEvenInsideAppleDouble;
- contentsForTextSystem;
- decodeTextPlain;
- decodeText;
- decodeTextRichtext;
- decodeTextEnriched;
- decodeTextHtml;
- decodeMultipart;
- decodeMultipartAlternative;
- decodeMultipartX_folder;
- decodeMessageDelivery_status;
- decodeMessageRfc822;
- decodeMessagePartial;
- decodeMessageExternal_body;
- decodeApplicationMac_binhex40;
- decodeApplicationApplefile;
- decodeMultipartAppledouble;
@end

@interface MimePart(IMAPSupport)
- (char)parseIMAPPropertyList:fp12;
- partNumber;
@end

@interface MimePart(MessageSupport)
- (char)parseMimeBody;
@end