/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation.
    All rights reserved.

    $Id: NSDataMessage.h,v 1.10 2002/08/21 03:17:17 wmalik Exp $
____________________________________________________________________________*/

#import <Foundation/NSData.h>

@interface NSMutableData(MimeDataEncoding)
- (void)appendQuotedPrintableDataForHeaderBytes:(const STR)fp12 length:(unsigned int)fp16;
@end

@interface NSMutableData(RFC2231Support)
- (void)appendRFC2231CompliantValue:fp12 forKey:fp16;
@end

@interface NSMutableData(NSDataUtils)
- (void)appendCString:(const STR)fp12;
- (void)appendByte:(char)fp12;
- (void)convertNetworkLineEndingsToUnix;
@end

@interface NSData(MimeDataEncoding)
+ (unsigned int)quotedPrintableLengthOfHeaderBytes:(const STR)fp12 length:(unsigned int)fp16;
- decodeQuotedPrintableForText:(char)fp12;
- encodeQuotedPrintableForText:(char)fp12;
- decodeBase64;
- (char)isValidBase64Data;
- encodeBase64WithoutLineBreaks;
- encodeBase64;
- decodeModifiedBase64;
- encodeModifiedBase64;
- encodeBase64HeaderData;
@end

@interface NSData(HFSDataConversion)
- wrapperForAppleFileDataWithFileEncodingHint:(unsigned int)fp12;
- wrapperForBinHex40DataWithFileEncodingHint:(unsigned int)fp12;
@end

@interface NSData(NSDataUtils)
- unquotedFromSpaceDataWithRange:(struct _NSRange)fp12;
- quotedFromSpaceDataForMessage;
- (struct _NSRange)rangeOfRFC822HeaderData;
- subdataToIndex:(unsigned int)fp12;
- subdataFromIndex:(unsigned int)fp12;
- (struct _NSRange)rangeOfData:fp16;
- (struct _NSRange)rangeOfData:fp16 options:(unsigned int)fp20;
- (struct _NSRange)rangeOfData:fp16 options:(unsigned int)fp20 range:(struct _NSRange)fp24;
- (struct _NSRange)rangeOfByteFromSet:fp16;
- (struct _NSRange)rangeOfByteFromSet:fp16 options:(unsigned int)fp20;
- (struct _NSRange)rangeOfByteFromSet:fp16 options:(unsigned int)fp20 range:(struct _NSRange)fp24;
- (struct _NSRange)rangeOfCString:(const STR)fp16;
- (struct _NSRange)rangeOfCString:(const STR)fp16 options:(unsigned int)fp20;
- (struct _NSRange)rangeOfCString:(const STR)fp16 options:(unsigned int)fp20 range:(struct _NSRange)fp24;
- componentsSeparatedByData:fp12;
- dataByConvertingUnixNewlinesToNetwork;
@end

@interface NSData(UuEnDeCode)
- uudecodedDataIntoFile:(id *)fp12 mode:(unsigned int *)fp16;
- uuencodedDataWithFile:fp12 mode:(unsigned int)fp16;
@end

