/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation.
    All rights reserved.

    $Id: PGPMailComposeBackEndPoser.m,v 1.4 2002/08/30 01:10:57 wmalik Exp $
____________________________________________________________________________*/

#import "PGPMailComposeBackEndPoser.h"
#import "PGPMailMessageEditor.h"
#import "PGPMailComposeAccessoryViewOwner.h"
#import <AppKit/AppKit.h>

#import <MVComposeAccessoryViewOwner.h>

@implementation PGPMailComposeBackEndPoser
static NSMapTable	*sPGPrealDelegates = NULL;

+ (void)load
{
    [PGPMailComposeBackEndPoser poseAsClass:[ComposeBackEnd class]];
    sPGPrealDelegates = NSCreateMapTable(NSNonRetainedObjectMapKeyCallBacks, NSNonRetainedObjectMapValueCallBacks, 3);
}

- (void)dealloc
{
    NSMapRemove(sPGPrealDelegates, self);
    
    [super dealloc];
}

- (void)setDelegate:(id)delegate
{
    if(delegate != nil)
        NSMapInsert(sPGPrealDelegates, self, delegate);
    else
        NSMapRemove(sPGPrealDelegates, self);
    [super setDelegate:self];
}

- (id)realDelegate
{
    return NSMapGet(sPGPrealDelegates, self);
}

- (void)backEndDidAppendMessageToOutbox:fp12 result:(int)fp16
{
    [[self realDelegate] backEndDidAppendMessageToOutbox:fp12 result:fp16];
}

- (char)backEnd:fp12 shouldDeliverMessage:fp16
{
    id							realDelegate = [self realDelegate];
    NSEnumerator				*theEnum = [[realDelegate pgpAccessoryViewOwners] objectEnumerator];
    MVComposeAccessoryViewOwner	*anOwner;

    while(anOwner = [theEnum nextObject])
    {
        if([anOwner isKindOfClass:[PGPMailComposeAccessoryViewOwner class]])
        {
            if([anOwner messageWillBeDelivered:fp16])
                break;
            else
            {
                NSBeep();
                return NO;
            }
        }
    }

    return [realDelegate backEnd:fp12 shouldDeliverMessage:fp16];
}

- (char)backEnd:fp12 shouldSaveMessage:fp16
{
    id							realDelegate = [self realDelegate];
    NSEnumerator				*theEnum = [[realDelegate pgpAccessoryViewOwners] objectEnumerator];
    MVComposeAccessoryViewOwner	*anOwner;

    while(anOwner = [theEnum nextObject])
    {
         if([anOwner isKindOfClass:[PGPMailComposeAccessoryViewOwner class]])
         {
            if([anOwner messageWillBeSaved:fp16])
                break;
            else
            {
                NSBeep();
                return NO;
            }
        }
    }
    
    return [[self realDelegate] backEnd:fp12 shouldSaveMessage:fp16];
}

- (void)backEndDidSaveMessage:fp12 result:(int)fp16
{
    [[self realDelegate] backEndDidSaveMessage:fp12 result:fp16];
}
@end
