/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: UConstantNames.cpp,v 1.3 2002/08/06 20:10:18 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"
#include "UConstantNames.h"

_USING_PGP

// Class UConstantNames variables

const UConstantNames::ConstantName UConstantNames::mDriverCommands[] =
{
	{DriverAPI::kNoOpCmdId,				"NoOp"}, 
	{DriverAPI::kQueryVersionCmdId,		"QueryVersion"}, 
	{DriverAPI::kQueryMountedCmdId,		"QueryMounted"}, 
	{DriverAPI::kQueryAllMountedCmdId,	"QueryAllMounted"}, 
	{DriverAPI::kNotifyUserLogoffCmdId,	"NotifyUserLogoff"}, 
	{DriverAPI::kSetTimeoutCmdId,		"SetTimeout"}, 
	{DriverAPI::kAreDisksTimedOutCmdId,	"AreDisksTimedOut"}, 
	{DriverAPI::kResetTimedOutCmdId,	"ResetTimedOut"}, 
	{DriverAPI::kMountCmdId,			"Mount"}, 
	{DriverAPI::kUnmountCmdId,			"Unmount"}, 
	{DriverAPI::kLockVolumeCmdId,		"LockVolume"}, 
	{DriverAPI::kUnlockVolumeCmdId,		"UnlockVolume"}, 
	{DriverAPI::kIOVolumeCmdId,			"IOVolume"}, 
};


// Class UConstantNames member functions

const char * 
UConstantNames::NameDriverCommand(DriverAPI::CommandId driverCommand)
{
	return GetName(mDriverCommands, sizeof(mDriverCommands) / 
		sizeof(ConstantName), driverCommand);
}

const char * 
UConstantNames::GetName(
	const ConstantName	table[], 
	PGPUInt32			size, 
	PGPUInt32			constant)
{
	for (PGPUInt32 i = 0; i < size; i++)
	{
		if (constant == table[i].constant)
			return table[i].name;
	}

	return "<Unknown>";
}
