/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: pgpDiskUI.h,v 1.3 2002/08/06 20:10:18 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_PGPdiskUI_h	/* [ */
#define Included_PGPdiskUI_h

/*
	To dynamic link to the PGPdisk UI lib, #define PGPDISK_DYNLINK and add
	the file 'pgpDiskUIDynLink.c' to your project. Then call these API
	functions normally. The Init and Cleanup functions below will load and
	unload the library, and the other functions when called will get their
	own proc pointer and invoke themselves, all through the wrappers defined
	in the above .c file.
*/

#ifdef __cplusplus
extern "C" {
#endif	/* __cplusplus */

#include "pgpDiskPubTypes.h"

/* Constants */

#ifdef PGP_WIN32

#ifdef PGPDISK_UI
#define PGPdiskUIExport __declspec(dllexport)
#else
#ifdef PGPDISK_DYNLINK
#define PGPdiskUIExport
#else
#define PGPdiskUIExport __declspec(dllimport)
#endif
#endif	/* PGPDISK_ENGINE */

#else
#error "PGP platform constant undefined or platform unsupported."
#endif	/* PGP_WIN32 */

/* Exported DLL functions */

/* DLL init/exit functions */

PGPError 
PGPdiskUIExport 
PGPdiskUIInitLibrary();

void 
PGPdiskUIExport 
PGPdiskUICleanupLibrary();

/* UI functions */

PGPError 
PGPdiskUIExport 
PGPdiskAskChooseDisk(PGPdiskContextRef context, const char *defaultPath, 
	const char *title, void *parentWnd, char *chosenPath, 
	PGPSize availLength);

PGPError 
PGPdiskUIExport 
PGPdiskAskMountDisk(PGPdiskContextRef context, const char *path, 
	void *parentWnd);

PGPError 
PGPdiskUIExport 
PGPdiskAskEditDisk(PGPdiskContextRef context, const char *path, 
	void *parentWnd);

PGPError 
PGPdiskUIExport 
PGPdiskAskCreateNewDisk(PGPdiskContextRef context, const char *defaultPath, 
	void *parentWnd);

PGPError 
PGPdiskUIExport 
PGPdiskFormatNewDisk(
	PGPdiskContextRef		context, 
	const char				*root, 
	const char				*volName, 
	int						fsType, 
	NewDiskStatusFuncType	userCallback, 
	void					*userValue);

enum
{
	kPGPdiskNoUnmountFlags			= 0x0000, 
	kPGPdiskForceUnmountFlag		= 0x0001,  
	kPGPdiskSilentUnmountFlag		= 0x0002, 
	kPGPdiskTimedOutUnmountAllFlag	= 0x0004,
	kPGPdiskShutdown				= 0x0008
};

PGPError 
PGPdiskUIExport 
PGPdiskAskUnmountDisk(PGPdiskContextRef context, const char *pathOrRoot,  
	void *parentWnd, PGPUInt32 flags);

PGPError 
PGPdiskUIExport 
PGPdiskAskUnmountAllDisks(PGPdiskContextRef context, void *parentWnd, 
	PGPUInt32 flags);

PGPError 
PGPdiskUIExport 
PGPdiskMountStartupDisks(PGPdiskContextRef context, void *parentWnd);

#ifdef PGP_WIN32

PGPError 
PGPdiskUIExport 
PGPdiskUIDiskDeleteHook(PGPdiskContextRef context, const char *path, 
	void *parentWnd, PGPBoolean *pProceedWithDelete);

#endif	/* PGP_WIN32 */

#ifdef __cplusplus
}
#endif	/* __cplusplus */

#endif /* ] Included_PGPdiskUI_h */
