/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: pgpDiskEngineMessages.h,v 1.17 2002/10/03 07:11:41 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_pgpDiskEngineMessages_h	/* [ */
#define Included_pgpDiskEngineMessages_h

/*
 * Values used for communication between diskapp and diskengine
 */

enum
{
	/* PGPdiskContextRef functions */
	kPGPdiskEngineMsg_NewContext,
	kPGPdiskEngineMsg_FreeContext,
	kPGPdiskEngineMsg_LoadKeyrings,
	kPGPdiskEngineMsg_SetADK,
	kPGPdiskEngineMsg_SetGlobalDiskTimeout,
	kPGPdiskEngineMsg_SetGlobalEjectOnLogout,
	kPGPdiskEngineMsg_SetPassphraseCaching,
	kPGPdiskEngineMsg_SetUnmountOnSleep,
	kPGPdiskEngineMsg_SetForcedAutoDiskUnmount,
	kPGPdiskEngineMsg_SetPreventSleep,
	kPGPdiskEngineMsg_GetEnginePID,

	/* PGPdiskUserRef functions */
	kPGPdiskEngineMsg_NewUserWithSymmetricKey,
	kPGPdiskEngineMsg_NewUserWithPublicKey,
	kPGPdiskEngineMsg_UserGetPGPKeyID,
	kPGPdiskEngineMsg_IsUserPassphraseCorrect,
	kPGPdiskEngineMsg_UserChangePassphrase,
	kPGPdiskEngineMsg_GetUserBooleanProp,
	kPGPdiskEngineMsg_GetUserNumericProp,
	kPGPdiskEngineMsg_GetUserDataProp,
	kPGPdiskEngineMsg_SetUserBooleanProp,
	kPGPdiskEngineMsg_SetUserNumericProp,
	kPGPdiskEngineMsg_SetUserDataProp,

	/* PGPdiskDiskRef functions */
	kPGPdiskEngineMsg_OpenDisk,
	kPGPdiskEngineMsg_CreateDisk,
	kPGPdiskEngineMsg_CreateDiskCallback,
	kPGPdiskEngineMsg_CreateDiskCallbackFinished,
	kPGPdiskEngineMsg_CloseDisk,
	kPGPdiskEngineMsg_FormatDisk,
	kPGPdiskEngineMsg_CanPassphraseMountDisk,
	kPGPdiskEngineMsg_MountDisk,
	kPGPdiskEngineMsg_UnmountDisk,
	kPGPdiskEngineMsg_DiskExportUserSet,
	kPGPdiskEngineMsg_DiskImportUserSet,
	kPGPdiskEngineMsg_ReEncryptDisk,
	kPGPdiskEngineMsg_ReEncryptDiskCallback,
	kPGPdiskEngineMsg_ReEncryptDiskCallbackFinished,
	kPGPdiskEngineMsg_ConvertDisk,
	kPGPdiskEngineMsg_ConvertDiskCallback,
	kPGPdiskEngineMsg_ConvertDiskCallbackFinished,
	kPGPdiskEngineMsg_GetDiskBooleanProp,
	kPGPdiskEngineMsg_GetDiskNumericProp,
	kPGPdiskEngineMsg_GetDiskDataProp,
	kPGPdiskEngineMsg_SetDiskBooleanProp,
	kPGPdiskEngineMsg_SetDiskNumericProp,
	kPGPdiskEngineMsg_SetDiskDataProp,

	/* Force to 32 bits */
	kPGPdiskEngineMsg_Invalid					= 0xFFFFFFFF
};

#endif /* ] Included_pgpDiskEngineMessages_h */
