/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: CPGPnetDriver.h,v 1.3 2002/08/06 20:10:26 dallen Exp $
____________________________________________________________________________*/

/*
	PGPnetDriver is a good place to hold global data
 */
#ifndef Included_CPGPnetDriver_h
#define Included_CPGPnetDriver_h

typedef struct _PGPnetPMContext	*PGPnetPMContextRef;

class CPGPnetDriver
{

public:

	PGPnetPMContextRef		PolicyManagerHandle;

	NDIS_SPIN_LOCK			general_lock;
	NDIS_SPIN_LOCK			doTransform_lock;

	PGPBoolean				Suspended;
	PGPBoolean				Resumed;

	// packet related field maybe should be moved down the tree.
    NDIS_HANDLE				packet_pool;
    NDIS_HANDLE				buffer_pool;

    PGPnetPacket*			free_packet_list;
    PGPnetPacketHead*		free_packet_head_list;

public:
	CPGPnetDriver();
	~CPGPnetDriver();

	PGPBoolean		isSuspended()	{ return Suspended; };
	PGPBoolean		isResumed()		{ return Resumed; };

	void			DriverLevelLock()	{NdisAcquireSpinLock(&general_lock);};
	void			DriverLevelUnlock() {NdisReleaseSpinLock(&general_lock);};

	NDIS_STATUS			AllocatePacketPool();
	VOID				FreePacketPool();

	virtual NDIS_STATUS Initialize() = 0;
	virtual VOID Uninitialize() = 0;

	static CPGPnetDriver* GetCurrentDriver();

};

#define PGPnetDriver CPGPnetDriver::GetCurrentDriver()

#endif // #define Included_CPGPnetDriver_h