/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpnetPacketHelper.h,v 1.2 2002/08/06 20:10:27 dallen Exp $ 
____________________________________________________________________________*/

#ifndef _H_PGPNET_PACKET_MGM_
#define _H_PGPNET_PACKET_MGM_

#ifdef __cplusplus
extern "C" {
#endif
/*******************************************************************************
 *******************************************************************************
 PGPnetPacket Related functions
 *******************************************************************************
 *******************************************************************************/

VOID PacketEnqueue(
    PPGPnetPacket* packet_list,
    PGPnetPacket* packet);

PGPnetPacket* PacketDequeue(
    PPGPnetPacket*packet_list);

PGPnetPacket* AllocatePGPnetPacket(VOID);

VOID FreePGPnetPacket(PGPnetPacket* packet);

PGPnetPacket* PacketRemoveByXformPacket(
		PPGPnetPacket*		packet_list,
		PNDIS_PACKET		packet);

PGPnetPacket* PacketRemoveBySrcPacket(
		PPGPnetPacket*		packet_list,
		PNDIS_PACKET		packet);

PGPnetPacket* PacketListRemove(
		PPGPnetPacket	*packet_list,
		PPGPnetPacket	packet);

VOID PGPCopyPacketToBlock(
		PNDIS_PACKET	packet,
		PUCHAR			block,
		PUINT			BytesCopied);

VOID PGPnetAdjustTransferCompletePacket(PGPnetPacket* pgpPacket);

VOID PGPnetAdjustXformPacket(PGPnetPacket* packet);

VOID PGPnetAdjustXformPackets(PGPnetPacket* packet);

VOID PGPnetAdjustSrcPacket(PGPnetPacket* packet, USHORT len);

VOID CopySrcBlockToXformBlock(PGPnetPacket *packet);

/*******************************************************************************
 *******************************************************************************
 PGPNET_PACKET_HEAD Related functions
 *******************************************************************************
 *******************************************************************************/

VOID PacketHeadEnqueue(
    PPGPnetPacketHead *packet_head_list,
    PPGPnetPacketHead packetHead);

PPGPnetPacketHead PacketHeadDequeue(
    PPGPnetPacketHead *packet_head_list);

VOID PacketHeadListRemove(
		PPGPnetPacketHead	*packet_list,
		PPGPnetPacketHead	packetHead);

PPGPnetPacketHead PacketHeadListQuery(
	PPGPnetPacketHead *packet_head_list,
	USHORT		 id,
	PGPUInt32		 ipAddress);

PPGPnetPacketHead PGPNdisPacketHeadAlloc(VOID);

VOID PGPNdisPacketHeadFreeList(
		PPGPnetPacketHead packetHead);

VOID PGPNdisPacketFreeList(
		PGPnetPacket* packet);

VOID PGPNdisPacketHeadFree(
		PPGPnetPacketHead packetHead);

VOID AppendPGPNdisPacket(
	PPGPnetPacketHead packetHead,
	PGPnetPacket* pgpPacket);

VOID AdjustPGPIPsecBuffer(
	PPGPnetPacketHead packetHead
	);

NDIS_STATUS AllocateDriverPacketPool(VOID);
VOID FreeDriverPacketPool(VOID);


#ifdef __cplusplus
}
#endif

#endif // #define _H_PGPNET_PACKET_MGM_