/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpNetPrefs.h,v 1.49 2002/08/06 20:10:25 dallen Exp $
____________________________________________________________________________*/
#ifndef Included_pgpNetPrefs_h	/* [ */
#define Included_pgpNetPrefs_h

#include "pflPrefs.h"
#include "pgpNetPrefsHostEntry.h"
#include "pgpNetPrefsBlockedEntry.h"
#include "pgpNetPrefsTrustedEntry.h"
#include "pgpNetPrefsFirewallRule.h"

#ifndef kPGPPrefFlags_All
#define kPGPPrefFlags_Hash			0x00000001
#define kPGPPrefFlags_Overwrite		0x00000002
#define kPGPPrefFlags_DisableGUI	0x00000004
#define kPGPPrefFlags_All			0xFFFFFFFF
#endif

#ifndef kPGPPrefAdminHash
#define kPGPPrefAdminHash			8000
#endif

#define kPGPNetPrefBase				10000

typedef struct PGPNetPrefIKEProposalEntry
{
	PGPikeAuthMethod			authMethod;
	PGPikeHash					hash;
	PGPikeCipher				cipher;
	PGPikeGroupID				groupID;
} PGPNetPrefIKEProposalEntry;

typedef struct PGPNetPrefIPSECProposalEntry
{
	PGPBoolean					useESP;
	PGPipsecESPTransformID		espCipher;
	PGPipsecAuthAttribute		espHash;
	PGPBoolean					useAH;
	PGPipsecAHTransformID		ahAuthAlg;
	PGPipsecAuthAttribute		ahHash;
	PGPBoolean					useIPCOMP;
	PGPipsecIPCOMPTransformID	ipcomp;
} PGPNetPrefIPSECProposalEntry;

typedef enum _PGPNetPrefsBool
{
	kPGPNetPrefBoolFirst					= kPGPNetPrefBase + 1000,
	kPGPNetPrefRequireValidKeyConfigured 	= kPGPNetPrefBoolFirst,
	kPGPNetPrefRequireValidKeyUnconfigured,
	kPGPNetPrefEnablePassphraseCache,
	kPGPNetPrefEnablePGPnet,
	kPGPNetPrefEnableVPN,
	kPGPNetPrefExpertMode,
	kPGPNetPrefEnableIKEKByteExpiration,
	kPGPNetPrefEnableIKETimeExpiration,
	kPGPNetPrefEnableIPSECKByteExpiration,
	kPGPNetPrefEnableIPSECTimeExpiration,
	kPGPNetPrefFirstExecution,
	kPGPNetPrefWarnReSharedSecret,
	kPGPNetPrefAllowCipherNone,
	kPGPNetPrefAllowCipherAES,
	kPGPNetPrefAllowCipherCAST,
	kPGPNetPrefAllowCipher3DES,
	kPGPNetPrefAllowCipherDES56,
	kPGPNetPrefAllowHashNone,
	kPGPNetPrefAllowHashSHA1,
	kPGPNetPrefAllowHashMD5,
	kPGPNetPrefAllowCompLZS,
	kPGPNetPrefAllowCompDeflate,
	kPGPNetPrefAllowDH768,
	kPGPNetPrefAllowDH1024,
	kPGPNetPrefAllowDH1536,
	kPGPNetPrefReplayDetection,
	kPGPNetPrefUseIntrusionDetection,
	kPGPNetPrefAutoBlockAttacks,
	kPGPNetPrefBlockUntilRemoved,
	kPGPNetPrefAttackEmailNotify,
	kPGPNetPrefAttackSound,
	kPGPNetPrefConfirmSADeletion,
	kPGPNetPrefConfirmLogClearing,
	kPGPNetPrefAttackNotify,
	kPGPNetPrefUseLearnMode,
	kPGPNetPrefEnableFirewall,
	kPGPNetPrefAttackDialog,
	kPGPNetPrefAllowEC163,
	kPGPNetPrefAllowEC283,
	kPGPNetPrefLogAllowed,
	kPGPNetPrefLogBlocked,
	kPGPNetPrefBoolLast
} PGPNetPrefsBool;

typedef enum _PGPNetPrefsNumber
{
	kPGPNetPrefNumberFirst					= kPGPNetPrefBase + 1200,
	kPGPNetPrefIKEKByteExpiration 			= kPGPNetPrefNumberFirst,
	kPGPNetPrefIKETimeExpiration,
	kPGPNetPrefIPSECKByteExpiration,
	kPGPNetPrefIPSECTimeExpiration,
	kPGPnetPrefIPSECGroupID,
	kPGPnetPrefUnconfiguredMode,
	kPGPnetPrefIKEPort,
	kPGPnetPrefBlockMinutes,
	kPGPnetPrefFirewallRuleSet,
	kPGPNetPrefTrustSubnetOption,
	kPGPnetPrefLastFirewallRuleListChange,
	kPGPNetPrefNumberLast
} PGPNetPrefsNumber;

typedef enum _PGPNetPrefsString
{
	kPGPNetPrefStringFirst					= kPGPNetPrefBase + 1400,
	kPGPNetPrefPublicKeyringFile			= kPGPNetPrefStringFirst,
	kPGPNetPrefPrivateKeyringFile,
	kPGPNetPrefAttackNotifyEmail,
	kPGPNetPrefAttackSoundName,
	kPGPNetPrefWhoisServer,
	kPGPNetPrefAttackNotifySMTPServer,
	kPGPNetPrefStringLast
} PGPNetPrefsString;

typedef enum _PGPNetPrefsByte
{
	kPGPNetPrefByteFirst					= kPGPNetPrefBase + 1600,
	kPGPNetPrefPGPAuthKeyID 				= kPGPNetPrefByteFirst,
	kPGPNetPrefX509AuthKeyID,
	kPGPNetPrefX509AuthCertIASN,
	kPGPNetPrefWinAppWindowData,
	kPGPNetPrefMacMainWindowPos,
	kPGPNetPrefByteLast
} PGPNetPrefsByte;

typedef enum _PGPNetPrefsArray
{
	kPGPNetPrefArrayFirst					= kPGPNetPrefBase + 1800,
	kPGPNetPrefHostArray 					= kPGPNetPrefArrayFirst,
	kPGPNetPrefIKEProposalArray,
	kPGPNetPrefIPSecProposalArray,
	kPGPNetPrefBlockedHostArray,
	kPGPNetPrefFirewallRuleArray,
	kPGPNetPrefKnownRuleArray,
	kPGPNetPrefSmartRuleArray,
	kPGPNetPrefTrustedHostArray,
	kPGPNetPrefAutoRuleArray,
	kPGPNetPrefArrayLast
} PGPNetPrefsArray;

typedef enum _PGPNetPrefsStruct
{
	kPGPNetPrefStructFirst					= kPGPNetPrefBase + 2000,
	kPGPNetPrefStructLast
} PGPNetPrefsStruct;



PGP_BEGIN_C_DECLARATIONS

extern const PGPPrefDefinition netDefaults[];
extern const PGPSize netDefaultsSize;

extern const PGPPrefDefinition hostDefaults[];
extern const PGPSize hostDefaultsSize;

extern const PGPPrefDefinition ruleDefaults[];
extern const PGPSize ruleDefaultsSize;

extern const PGPPrefDefinition knownRuleDefaults[];
extern const PGPSize knownRuleDefaultsSize;

extern const PGPNetPrefIKEProposalEntry sDefaultIKEProposals[];
extern const PGPSize sDefaultIKEProposalsSize;

extern const PGPNetPrefIPSECProposalEntry sDefaultIPSECProposals[];
extern const PGPSize sDefaultIPSECProposalsSize;


/*
	The following are used for getting/setting data structures
	stored in the preference file
*/
	PGPError
PGPGetNetHostPrefs(
		PGPPrefRef				prefRef,
		PGPNetPrefHostEntry		**netHostList,
		PGPUInt32				*netHostCount);

	PGPError
PGPSetNetHostPrefs(
		PGPPrefRef				prefRef,
		PGPNetPrefHostEntry		*netHostList,
		PGPUInt32				netHostCount);

	PGPError
PGPGetNetBlockedPrefs(
		PGPPrefRef				prefRef,
		PGPNetPrefBlockedEntry	**blockedList,
		PGPUInt32				*blockedCount);

	PGPError
PGPSetNetBlockedPrefs(
		PGPPrefRef				prefRef,
		PGPNetPrefBlockedEntry	*blockedList,
		PGPUInt32				blockedCount);

	PGPError
PGPGetNetTrustedPrefs(
		PGPPrefRef				prefRef,
		PGPNetPrefTrustedEntry  **trustedList,
		PGPUInt32				*trustedCount);

	PGPError
PGPSetNetTrustedPrefs(
  		PGPPrefRef				prefRef,
		PGPNetPrefTrustedEntry  *trustedList,
		PGPUInt32				trustedCount);

	PGPError
PGPGetNetFirewallRuleSet(
		PGPPrefRef					prefRef,
		PGPNetPrefFirewallRule		**ruleList,
		PGPUInt32					*ruleCount);

	PGPError
PGPGetNetDefaultFirewallRuleSet(
		PGPPrefRef					prefRef,
		PGPUInt32					setNum,
		PGPNetPrefFirewallRule		**ruleList,
		PGPUInt32					*ruleCount);

	PGPError
PGPGetNetFirewallCustomRules(
		PGPPrefRef					prefRef,
		PGPNetPrefFirewallRule		**ruleList,
		PGPUInt32					*ruleCount);

	PGPError
PGPSetNetFirewallRulePrefs(
		PGPPrefRef					prefRef,
		PGPNetPrefFirewallRule		*ruleList,
		PGPUInt32					ruleCount );

	PGPError
PGPGetNetKnownRuleSet(
		PGPPrefRef					prefRef,
		PGPNetPrefsArray			netPrefArray,
		PGPNetPrefFirewallRule		**ruleList,
		PGPUInt32					*ruleCount );

	PGPError
PGPGetNetDefaultKnownRuleSet(
		PGPPrefRef					prefRef,
		PGPNetFirewallSet			setNum,
		PGPNetPrefFirewallRule		**ruleList,
		PGPUInt32					*ruleCount );

	PGPError
PGPSetNetKnownRuleSet(
		PGPPrefRef					prefRef,
		PGPNetPrefsArray			netPrefArray,
		PGPNetPrefFirewallRule		*ruleList,
		PGPUInt32					ruleCount );

	PGPError
PGPGetNetIKEProposalPrefs(
		PGPPrefRef					prefRef,
		PGPNetPrefIKEProposalEntry	**proposalList,
		PGPUInt32					*proposalCount);

	PGPError
PGPSetNetIKEProposalPrefs(
		PGPPrefRef					prefRef,
		PGPNetPrefIKEProposalEntry	*proposalList,
		PGPUInt32					proposalCount);

	PGPError
PGPGetNetIPSECProposalPrefs(
		PGPPrefRef						prefRef,
		PGPNetPrefIPSECProposalEntry	**proposalList,
		PGPUInt32						*proposalCount);

	PGPError
PGPSetNetIPSECProposalPrefs(
		PGPPrefRef						prefRef,
		PGPNetPrefIPSECProposalEntry	*proposalList,
		PGPUInt32						proposalCount);


PGP_END_C_DECLARATIONS


#endif /* ] Included_pgpNetPrefs_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
