/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: PGPBundle.h,v 1.24 2002/08/29 23:09:36 jeffc Exp $
____________________________________________________________________________*/

@protocol PGPBundle

+ (NSString*)identifier;

- (id)init;
- (id)initWithController:(id)controller;

- (id)prefsController;
- (NSWindow*)window;
- (NSImage*)menuImage;
- (NSMenu*)dockMenu;
- (NSMenuItem*)newMenuItem;

- (void)activate:(BOOL)passive;
- (void)addMenus;
- (void)handleDocument:(NSString*)docFile ofType:(NSString*)docType;

- (id)controller;
- (void)setController:(id)controller;

- (BOOL)releaseIfReadyToShutdown;

/* SDK notification callbacks */
- (void)keyDBChanged;
- (void)passphraseCacheChanged;

@end
