/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: PGPOpenPrefs.h,v 1.9 2002/08/06 20:10:27 dallen Exp $
____________________________________________________________________________*/

#include "pflPrefs.h"
#include "pgpPFLErrors.h"
#include "pgpUtilities.h"
#include "pgpNetService.h"

extern const char *	kPGPclPrefsClientKey;
extern const char * kPGPclPrefsNetKey;


enum PGPclPrefNotificationType_ {
	kPGPclPrefNotification_PrefsUpdated = 0,

	PGP_ENUM_FORCE(PGPclPrefNotificationType_)
};
PGPENUM_TYPEDEF(PGPclPrefNotificationType_, PGPclPrefNotificationType);


typedef void (*PGPclPrefNotifierProc)(PGPclPrefNotificationType, PGPPrefRef);

PGPError	PGPclOpenPrefs(PGPMemoryMgrRef inMemoryMgr, const char * inKey,
				PGPclPrefNotifierProc inProc, PGPPrefRef * outPrefRef,
				PGPBoolean inUseNotification);		/*	inProc can be NULL	*/
PGPError	PGPclWritePrefs(PGPPrefRef inPrefRef);

PGPError	PGPclPeekNetPrefs(PGPnetContextRef netContext, PGPPrefRef * outPrefRef);
PGPError	PGPclFlushNetPrefs(PGPnetContextRef netContext, PGPPrefRef inPrefRef);
void		PGPclSetNetPrefs(PGPPrefRef	inPrefRef);
void		PGPclFreeNetPrefs();

