/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: PGPSharedEncryptDecrypt.h,v 1.4 2002/08/06 20:10:27 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_PGPSharedEncryptDecrypt_h	/* [ */
#define Included_PGPSharedEncryptDecrypt_h


PGP_BEGIN_C_DECLARATIONS

typedef PGPError (*PGPSharedForEackKeyDoProcPtr)( PGPKeyIterRef keyIterator,
							PGPKeyDBObjRef theKey, void *userData );


typedef struct PGPSharedKeyProperties
{
	PGPBoolean	isSecret;
	PGPBoolean	isAxiomatic;
	PGPBoolean	isSplit;
	PGPBoolean	isRevoked;
	PGPBoolean	isDisabled;
	PGPBoolean	isCorrupt;
	PGPBoolean	isExpired;
	PGPBoolean	canSign;		// Special ViaCrypt property
	PGPBoolean	canEncrypt;		// Special ViaCrypt property

	PGPValidity	userValidity;	// Valid for a particular user ID only
	
} PGPSharedKeyProperties;


PGPError	CountKeysInDefaultKeyring(PGPContextRef context, PGPPrefRef prefRef,
						PGPUInt32 *numPublicKeys, PGPUInt32 *numPrivateKeys);
	
PGPError	PGPSharedForEachKeyDo( PGPContextRef context, PGPPrefRef prefRef,
						PGPKeyOrdering keyOrdering, PGPBoolean reverseOrder,
						PGPSharedForEackKeyDoProcPtr callbackProc,
						void *callbackData);
	
PGPError	PGPSharedGetKeyProperties(PGPKeyDBObjRef theKey, const char *userID,
						PGPSharedKeyProperties *properties);
						
PGPError	PGPSharedGetIndKeyFromKeySet(PGPKeySetRef keySet,
						PGPKeyOrdering keyOrdering, PGPBoolean reverseOrdering,
						PGPUInt32 searchIndex, PGPKeyDBObjRef *theKey);
	
PGP_END_C_DECLARATIONS

#endif /* ] Included_PGPSharedEncryptDecrypt_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
