/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: UAppleEvents.h,v 1.2 2002/08/06 20:10:27 dallen Exp $
____________________________________________________________________________*/
#include <Carbon/Carbon.h>

class StAEDescriptor
{
public:
	AEDesc	mDesc;
			
			operator	AEDesc*()				{ return &mDesc; }
			operator	AEDesc&() 				{ return mDesc; }
	
			StAEDescriptor();
			
			StAEDescriptor(
					const AEDesc&	inDesc,
					AEKeyword		inKeyword,
					DescType		inDesiredType = typeWildCard);
					
			StAEDescriptor(DescType inType, const void *inData, SInt32 inSize);
			
			StAEDescriptor(Boolean inBoolean);
			
			StAEDescriptor(SInt16 inInt16);
			
			StAEDescriptor(SInt32 inInt32);
			
			StAEDescriptor(OSType inOSType);
			
			StAEDescriptor(ConstStringPtr inString);
			
			StAEDescriptor(const FSSpec& inFileSpec);
			
			~StAEDescriptor();
			
			
	StAEDescriptor&		operator = (Boolean inBoolean)
							{
								return Assign(inBoolean);
							}
							
	StAEDescriptor&		operator = (SInt16 inInt16)
							{
								return Assign(inInt16);
							}
							
	StAEDescriptor&		operator = (SInt32 inInt32)
							{
								return Assign(inInt32);
							}
							
	StAEDescriptor&		operator = (OSType inOSType)
							{
								return Assign(inOSType);
							}
							
	StAEDescriptor&		operator = (ConstStringPtr inString)
							{
								return Assign(inString);
							}
							
	StAEDescriptor&		operator = (const FSSpec& inFileSpec)
							{
								return Assign(inFileSpec);
							}
							
	StAEDescriptor&		Assign(Boolean inBoolean);
							
	StAEDescriptor&		Assign(SInt16 inInt16);
							
	StAEDescriptor&		Assign(SInt32 inInt32);
							
	StAEDescriptor&		Assign(OSType inOSType);
							
	StAEDescriptor&		Assign(ConstStringPtr inString);
							
	StAEDescriptor&		Assign(const FSSpec& inFileSpec);
				
	void	Dispose();
	
	bool	IsNull() const			{ return (mDesc.descriptorType == typeNull); }
	
	bool	IsNotNull() const		{ return (mDesc.descriptorType != typeNull); }
	
	DescType	DescriptorType() const	{ return mDesc.descriptorType; }
			
	void	GetParamDesc(
					const AppleEvent&	inAppleEvent,
					AEKeyword			inKeyword,
					DescType			inDesiredType);
							
	void	GetOptionalParamDesc(
					const AppleEvent&	inAppleEvent,
					AEKeyword			inKeyword,
					DescType			inDesiredType);
					
private:
	void	InitToNull()
				{
					mDesc.descriptorType = typeNull;
					mDesc.dataHandle     = nil;
				}
};

