/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpClientPrefs.h,v 1.85 2002/11/16 19:26:15 pbj Exp $
____________________________________________________________________________*/
#ifndef Included_pgpClientPrefs_h	/* [ */
#define Included_pgpClientPrefs_h

#include "pgpBase.h"
#include "pflPrefs.h"

#if PGP_MACINTOSH
#include <Menus.h>
#endif

#ifndef kPGPPrefFlags_All
#define kPGPPrefFlags_Hash			0x00000001
#define kPGPPrefFlags_Overwrite		0x00000002
#define kPGPPrefFlags_DisableGUI	0x00000004
#define kPGPPrefFlags_All			0xFFFFFFFF
#endif

#ifndef kPGPPrefAdminHash
#define kPGPPrefAdminHash			8000
#endif

enum
{
	kPGPPrefMacBinaryOff		= 1,
	kPGPPrefMacBinarySmart		= 2,
	kPGPPrefMacBinaryOn			= 3
};

enum
{
	kPGPPrefCacheTypeNone		= 0,
	kPGPPrefCacheTypeSeconds	= 1,
	kPGPPrefCacheTypeLogon		= 2
};

enum
{
	kPGPPrefCertRequestCRS		= 0,
	kPGPPrefCertRequestPKCS10	= 1
};

enum
{
	kPGPPrefPGPNotInitialized	= 0,
	kPGPPrefPGPDisabled			= 1,
	kPGPPrefPGPInitialized		= 2
};

typedef enum _PGPClientPrefsBool
{
	kPGPPrefBoolFirst							=	0,
	kPGPPrefEncryptToSelf = kPGPPrefBoolFirst,
	kPGPPrefWordWrapEnable,
	kPGPPrefShareCache,
	kPGPPrefMailEncryptPGPMIME,
	kPGPPrefMailSignPGPMIME,
	kPGPPrefFastKeyGen,
	kPGPPrefMailEncryptDefault,
	kPGPPrefMailSignDefault,
	kPGPPrefMarginalIsInvalid,
	kPGPPrefDisplayMarginalValidity,
	kPGPPrefFirstKeyGenerated,
	kPGPPrefAutoDecrypt,
	kPGPPrefExportKeysCompatible,
	kPGPPrefAlwaysUseSecureViewer,
	kPGPPrefHookCBTWin,
	kPGPPrefUseHexFingerprint,
	kPGPPrefTrashIntegration,
	kPGPPrefAutoWipeOnDelete,
	kPGPPrefShowWipeProgress,
	kPGPPrefShowPGPkeysToolbar,
	kPGPPrefShowTrayIcon,
	kPGPPrefWarnOnRSARecipAndNonRSASigner,
	kPGPPrefWarnOnReadOnlyKeyRings,
	kPGPPrefWarnOnWipe,
	kPGPPrefWarnOnADK,
	kPGPPrefWarnOnMemLockFailure,
	kPGPPrefKeyServerSyncUnknownKeys,
	kPGPPrefKeyServerSyncOnAdd,
	kPGPPrefKeyServerSyncOnKeySign,
	kPGPPrefKeyServerSyncOnRevocation,
	kPGPPrefKeyServerSyncOnVerify,
	kPGPPrefDiskDefaultMountAtStartup,
	kPGPPrefDiskWarnOnDeletion,
//	kPGPPrefDiskBrowseAfterMount,
	kPGPPrefDiskAutoUnmountOnLogout,
	kPGPPrefDiskAutoUnmountOnSleep,
	kPGPPrefDiskNoSleepIfFailAU,
	kPGPPrefDiskUnmountOnInactivity,
	kPGPPrefDiskWarnIfUnmountFail,
	kPGPPrefDiskAllowForcibleUnmounts,
	kPGPPrefDiskAlwaysForceUnmounts,
	kPGPPrefTempestFont,
	kPGPPrefIdleAutoLockScreen,
	kPGPPrefAutoBackupKeyring,
	kPGPPrefAutoBackupToKeyringFolder,
	kPGPPrefWin32OutlookConvertMessages,
	kPGPPrefWin32OutlookAttachment,
	kPGPPrefWin32OutlookHTMLEncrypt,
	kPGPPrefWin32OutlookHTMLDecrypt,
	kPGPPrefWin32EudoraOutputPGPMIME,
	kPGPPrefWin32OutlookNotFromExplorer,
	kPGPPrefWin32OutlookExchangeID,
	kPGPPrefReportToEPO,
	kPGPPrefBoolLast
} PGPClientPrefsBool;

typedef enum _PGPClientPrefsNumber
{
	kPGPPrefNumberFirst							=	200,
	kPGPPrefVersion = kPGPPrefNumberFirst,
	kPGPPrefWordWrapWidth,
	kPGPPrefCacheType,
	kPGPPrefCacheSeconds,
	kPGPPrefPreferredAlgorithm,
	kPGPPrefMacBinaryDefault,
	kPGPPrefFileWipePasses,
	kPGPPrefDiskWipePasses,
	kPGPPrefLastSearchWindowSelection,
	kPGPPrefLastAllKeysUpdate,				/* PGPTime */
	kPGPPrefLastTrustedIntroducersUpdate,	/* PGPTime */
	kPGPPrefCAType,
	kPGPPrefNextAutoCRLUpdate,
	kPGPPrefDiskLastCreateSize,
	kPGPPrefDiskLastCreateScale,
	kPGPPrefDiskAutoUnmountTimeout,
	kPGPPrefDiskLastAlgorithm,
	kPGPPrefDiskLastFileSystem,
	kPGPPrefLastPrefsUpdate,
	kPGPPrefMetaIntroducerTrustDepth,
	kPGPPrefIdleAutoLockScreenMinutes,
	kPGPPrefLastCertRequest,
	kPGPPrefAutoBackupDirIDMac,
	kPGPPrefUserAccountStatus,
	kPGPPrefLDAPPrefsServerAlg,
	kPGPPrefNumberLast
} PGPClientPrefsNumber;

typedef enum _PGPClientPrefsString
{
	kPGPPrefStringFirst							=	400,
	kPGPPrefComment = kPGPPrefStringFirst,
	kPGPPrefCAServerURL,
	kPGPPrefCARevocationServerURL,
	kPGPPrefDiskLastOpenDir,
	kPGPPrefDiskLastSaveDir,
	kPGPPrefDiskLastCreateRoot,
	kPGPPrefPublicKeyringFile,
	kPGPPrefPrivateKeyringFile,
	kPGPPrefRNGSeedFile,
	kPGPPrefDiskMountAtStartupPaths,
	kPGPPrefAutoBackupFolder,
	kPGPPrefLDAPPrefsServerKeyID,
    kPGPPrefPKCS11DrvFile, 
	kPGPPrefLicenseName,
	kPGPPrefLicenseCompany,
    kPGPPrefStringLast
} PGPClientPrefsString;

typedef enum _PGPClientPrefsByte
{
	/* Remember byte prefs are generally not platform-independent!  */
	kPGPPrefByteFirst							=	600,
	kPGPPrefPGPtoolsMacPrivateData = kPGPPrefByteFirst,
	kPGPPrefPGPmenuMacAppSignatures,
	kPGPPrefPGPkeysMacMainWinPos,
	kPGPPrefPGPkeysMacColumnData,
	kPGPPrefHotKeyDataMac,
	kPGPPrefPGPkeysWinMainWinPos,
	kPGPPrefPGPkeysWinColumnData,
	kPGPPrefPGPkeysWinGroupsData,
	kPGPPrefCARootKeyID,
	kPGPPrefCARootX509IASN,
	kPGPPrefCAServerAuthKeyID,
	kPGPPrefCARevocationServerAuthKeyID,
	kPGPPrefHotKeyData,
	kPGPPrefDiskEditorWinPos,
	kPGPPrefDiskEditorWinPosMac,
	kPGPPrefPublicKeyringFileMac,
	kPGPPrefPrivateKeyringFileMac,
	kPGPPrefRNGSeedFileMac,
	kPGPPrefDefaultKeyID,
	kPGPPrefLoginWindowsInfo,
	kPGPPrefRequestedCertKeyID,
	kPGPPrefLicenseNumber,
	kPGPPrefLicenseAuthorization,
	kPGPPrefByteLast
} PGPClientPrefsByte;

typedef enum _PGPClientPrefsStruct
{
	kPGPPrefStructFirst							=	800,
	kPGPPrefStructLast
} PGPClientPrefsStruct;

typedef enum _PGPClientPrefsArray
{
	kPGPPrefArrayFirst							=	1000,
	kPGPPrefKeyServerList = kPGPPrefArrayFirst,
	kPGPPrefAllowedAlgorithmsList,
	kPGPPrefArrayLast
} PGPClientPrefsArray;

typedef enum _PGPAdminPrefsBool
{
	kPGPAdminPrefBoolFirst						=	3000,
	kPGPPrefUseOutgoingADK = kPGPAdminPrefBoolFirst,
	kPGPPrefUseDHADK,
	kPGPPrefEnforceIncomingADK,
	kPGPPrefEnforceMinChars,
	kPGPPrefEnforceMinQuality,
	kPGPPrefWarnNotCertByCorpIsNoLongerUsed,	/* Replace this with something else */
	kPGPPrefAutoSignTrustCorp,
	kPGPPrefMetaIntroducerCorp,
	kPGPPrefAllowConventionalEncryption,
	kPGPPrefEnforceOutgoingADK,
	kPGPPrefEnforceRemoteADKClass,
	kPGPPrefUpdateAllKeys,
	kPGPPrefUpdateTrustedIntroducers,
	kPGPPrefAutoAddRevoker,
	kPGPPrefUsePGPdiskADK,
	kPGPPrefKeyGenX509CertRequest,
	kPGPPrefAllowManualX509CertRequest,
	kPGPPrefAutoUpdateX509CRL,
	kPGPPrefAllowKeyGeneration,
	kPGPPrefPresetKeyGeneration,
	kPGPPrefAlwaysSendKeys,
	kPGPPrefAutoKeyReconstruction,
	kPGPPrefUpdatePrefs,
	kPGPPrefAddLotusNotesUserID,
	kPGPPrefAutoSignRootCAKey,
	kPGPPrefAllowEncryptInvalidKeys,
	kPGPPrefAllowKeySigning,
	kPGPPrefDiskUseDefaultKey,
	kPGPPrefCopyClientPrefs,
	kPGPPrefCopyNetHosts,
	kPGPPrefMergeNetHosts,
	kPGPPrefPreselectInstall,
	kPGPPrefInstallPrograms,
	kPGPPrefInstallLogin,
	kPGPPrefInstallNet,
	kPGPPrefInstallFire,
	kPGPPrefInstallDisk,
	kPGPPrefInstallEudora,
	kPGPPrefInstallOutlook,
	kPGPPrefInstallOutlookExpress,
	kPGPPrefInstallICQ,
	kPGPPrefInstallLotusNotes,
	kPGPPrefInstallDocumentation,
	kPGPPrefUninstallOldPGP,
	kPGPPrefRebootAfterSilentInstall,
	kPGPPrefAutoAddExchangeServerAddress,
	kPGPPrefGenerateKeysOnSmartCard,
	kPGPPrefDisableAutoUpgrade,
	kPGPPrefInstallGroupwise,
	kPGPPrefDiskCreate,
	kPGPPrefRemainSilentAfterInstall,
	kPGPAdminPrefBoolLast
} PGPAdminPrefsBool;

typedef enum _PGPAdminPrefsNumber
{
	kPGPAdminPrefNumberFirst					=	3200,
	kPGPAdminPrefVersion = kPGPAdminPrefNumberFirst,
	kPGPPrefMinChars,
	kPGPPrefMinQuality,
	kPGPPrefDaysUpdateAllKeys,
	kPGPPrefDaysUpdateTrustedIntroducers,
	kPGPPrefKeySize,
	kPGPPrefDaysUpdatePrefs,
	kPGPPrefKeyPublicKeyAlgorithm,
	kPGPPrefKeyExpiration,
	kPGPPrefLDAPReconServerType,
	kPGPPrefCertRequestType,
	kPGPPrefCorpKeyTrustDepth,
	kPGPPrefDiskSize,
	kPGPPrefDiskAlgorithm,
	kPGPPrefDiskFileSystem,
	kPGPAdminPrefNumberLast
} PGPAdminPrefsNumber;

typedef enum _PGPAdminPrefsString
{
	kPGPAdminPrefStringFirst					=	3400,
	kPGPPrefLDAPPrefsServer = kPGPAdminPrefStringFirst,
	kPGPPrefLDAPReconServer,
	kPGPPrefInstallDir,
	kPGPPrefCompanyName,
	kPGPAdminPrefStringLast
} PGPAdminPrefsString;

typedef enum _PGPAdminPrefsByte
{
	kPGPAdminPrefByteFirst						=	3600,
	kPGPPrefOutgoingADKID = kPGPAdminPrefByteFirst,
	kPGPPrefDHADKID,
	kPGPPrefCorpKeyID,
	kPGPPrefRevokerKeyID,
	kPGPPrefPGPdiskADKKeyID,
	kPGPPrefExtraAVPairs,
	kPGPAdminPrefByteLast
} PGPAdminPrefsByte;

typedef enum _PGPAdminPrefsStruct
{
	kPGPAdminPrefStructFirst					=	3800,
	kPGPAdminPrefStructLast
} PGPAdminPrefsStruct;

typedef enum _PGPAdminPrefsArray
{
	kPGPAdminPrefArrayFirst						=	4000,
	kPGPPrefDefaultKeys = kPGPAdminPrefArrayFirst,
	kPGPAdminPrefArrayLast
} PGPAdminPrefsArray;

#if	PGP_MACINTOSH	/* [ */

#if PGP_MACINTOSH
#pragma options align=mac68k
#endif

typedef struct PGPmenuApps
{
	PGPBoolean	privateScrap;
	PGPBoolean	useOutputDialog;
	OSType		creator;
	Str31		appName;
} PGPmenuApps;

typedef struct PGPmenuHotkeys
{
	UInt8		encryptModifiers;
	UInt8		encryptKey;
	UInt8		signModifiers;
	UInt8		signKey;
	UInt8		encryptSignModifiers;
	UInt8		encryptSignKey;
	UInt8		decryptModifiers;
	UInt8		decryptKey;
	UInt8		lockScreenModifiers;
	UInt8		lockScreenKey;
	UInt8		purgeCacheModifiers;
	UInt8		purgeCacheKey;
} PGPmenuHotkeys;

#if PGP_MACINTOSH
#pragma options align=reset
#endif

#endif	/* ] */


PGP_BEGIN_C_DECLARATIONS

extern const PGPPrefDefinition clientDefaults[];
extern const PGPSize clientDefaultsSize;

extern PGPPrefStruct LDAPKeyServer;
extern PGPPrefStruct EuroKeyServer;
extern PGPPrefArray DefaultKeyServer;

extern PGPPrefArray DefaultKeys;

PGP_END_C_DECLARATIONS


#endif /* ] Included_pgpClientPrefs_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
