/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: UString.cpp,v 1.2 2002/08/06 20:10:38 dallen Exp $
____________________________________________________________________________*/

#include "pgpClassesConfig.h"
#include <stdio.h>

#include "UString.h"

_USING_PGP

// Functions

// SmartStringCopy copies either 'inString' in its entirety to 'outString', 
// or 'outBufSize' chars of 'inString', whichever is smaller, and appends a 
// null character.

void 
UString::SmartStringCopy(
	char		*outString, 
	const char	*inString, 
	PGPUInt32	outBufSize)
{
	PGPUInt16	numToCopy;

	pgpAssertAddrValid(outString, char);
	pgpAssertStrValid(inString);

	numToCopy = pgpMin(strlen(inString), outBufSize - 1);

	strncpy(outString, inString, numToCopy);
	outString[numToCopy] = '\0';
}
