/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: MacNew.cp,v 1.4 2002/08/06 20:10:40 dallen Exp $
____________________________________________________________________________*/

#include <stddef.h>

#include "MacNew.h"

#if USE_MAC_OPERATOR_NEW
#error use 'USE_PGP_OPERATOR_NEW'
#endif


#if USE_PGP_OPERATOR_NEW	// [

#include <new>


/* Temporarily disable leaks tracking */
#undef NewPtr
#undef DisposePtr

MacNewDummy::MacNewDummy()
{
}

/*____________________________________________________________________________
	With the modern memory manager, NewPtr() is substantially faster
	than MetroWerks operator new().
____________________________________________________________________________*/
	void *
operator new(size_t size)
{
	void *ptr;
	
#if MEMORY_ALLOC_MUST_BE_APP
	pgpAssertMsg( GetZone() == ApplicationZone(),
		"operator new: MEMORY_ALLOC_MUST_BE_APP");
#elif MEMORY_ALLOC_MUST_BE_SYS
	pgpAssertMsg( GetZone() == SystemZone(),
		"operator new: MEMORY_ALLOC_MUST_BE_SYS");
#elif MEMORY_ALLOC_MUST_BE_SYS_OR_TEMP
	pgpAssertMsg( GetZone() == SystemZone(),
		"operator new: MEMORY_ALLOC_MUST_BE_SYS_OR_TEMP");
#elif MEMORY_ALLOC_MUST_BE_APP_OR_SYS
	pgpAssertMsg( GetZone() == ApplicationZone() || GetZone() == SystemZone(),
		"operator new: MEMORY_ALLOC_MUST_BE_APP_OR_SYS");
#endif

	ptr	= NewPtr( size );

#if PGP_OPERATOR_NEW_THROWS_BAD_ALLOC
	if (ptr == 0) {
		throw bad_alloc();
	}
#endif

	return ptr;
}
	
	
	void
operator delete(void *ptr)
{
	if( ptr != 0 )
	{
		DisposePtr( (Ptr) ptr );
	}
}



	void *
operator new[](size_t size)
{
	void *ptr;
	
#if MEMORY_ALLOC_MUST_BE_APP
	pgpAssertMsg( GetZone() == ApplicationZone(),
		"operator new: MEMORY_ALLOC_MUST_BE_APP");
#elif MEMORY_ALLOC_MUST_BE_SYS
	pgpAssertMsg( GetZone() == SystemZone(),
		"operator new: MEMORY_ALLOC_MUST_BE_SYS");
#elif MEMORY_ALLOC_MUST_BE_SYS_OR_TEMP
	pgpAssertMsg( GetZone() == SystemZone(),
		"operator new: MEMORY_ALLOC_MUST_BE_SYS_OR_TEMP");
#elif MEMORY_ALLOC_MUST_BE_APP_OR_SYS
	pgpAssertMsg( GetZone() == ApplicationZone() || GetZone() == SystemZone(),
		"operator new: MEMORY_ALLOC_MUST_BE_APP_OR_SYS");
#endif

	ptr	= NewPtr( size );

#if PGP_OPERATOR_NEW_THROWS_BAD_ALLOC
	if (ptr == 0) {
		throw bad_alloc();
	}
#endif

	return ptr;
}
	
	
	void
operator delete[](void *ptr)
{
	if( ptr != 0 )
	{
		DisposePtr( (Ptr) ptr );
	}
}

#endif	// ]