/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	$Id: MacTraps.c,v 1.4 2002/08/06 20:10:40 dallen Exp $
____________________________________________________________________________*/

#include <Traps.h>

#include "MacTraps.h"

#define kToolTrapMask 0x0800

	short
NumberOfToolboxTraps(void)
{
	if( NGetTrapAddress( _InitGraf, ToolTrap ) ==
			NGetTrapAddress( 0xAA6E, ToolTrap ) )
	{
		return( 0x0200 );
	}
	else
	{
		return( 0x0400 );
	}
}

	TrapType
GetTypeOfTrap(short theTrap)
{
	if( (theTrap & kToolTrapMask) != 0 )
	{
		return ( ToolTrap );
	}
	else
	{
		return ( OSTrap );
	}
}

	Boolean
MacOSTrapAvailable(short theTrap)
{
	TrapType	trapType;

	trapType = GetTypeOfTrap(theTrap);
	if(trapType == ToolTrap)
	{
		theTrap = theTrap & 0x07FF;
	}
	
	if ( theTrap >= NumberOfToolboxTraps() )
	{
		theTrap = _Unimplemented;
	}
	
	return ( NGetTrapAddress( theTrap, trapType ) !=
		NGetTrapAddress( _Unimplemented, ToolTrap ) );
}

	Boolean
PFLPatchTrap(short trapNum, UniversalProcPtr newAddr, UniversalProcPtr *oldAddr)
{
	TrapType			trapType;
	
	trapType	= GetTypeOfTrap( trapNum );
	*oldAddr	= NGetTrapAddress( trapNum, trapType );
	newAddr		= (UniversalProcPtr) StripAddress( newAddr );
	
	if ( newAddr != *oldAddr )
	{
		NSetTrapAddress( newAddr, trapNum, trapType );
		return( TRUE );
	}
	
	return( FALSE );
}
