/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: CPGPservice.h,v 1.17 2002/08/06 20:10:56 dallen Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>
#import <PGP/PGPPrivate.h>
#import <PGP/PGPserviceProtocol.h>


@interface CPGPservice : NSObject < PGPserviceProtocol > {
@private
	NSPipe *			signalPipe;
	NSTimer *			stopTimer;
	NSTimer *			cacheTimer;
	BOOL				sdkInitialized;
	PGPContextRef		pgpContext;
	PGPInt16			connCount;
	PGPInt16			stopTimerSeconds;
}
	- (void)			terminate:(id)sender;
	- (void)			handleSignals:(id)notification;
	
	- (void)			scheduleStopTimer;
	- (void)			cancelStopTimer;
	
	- (void)			startCacheTimer;
	- (void)			checkCacheExpirations:(NSTimer *)timer;

	- (void)			connectionInitialized:(NSNotification *)notification;
	- (void)			connectionDied:(NSNotification *)notification;

@end

extern CPGPservice *	gApp;