/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	$Id: PGPUICocoaPriv.m,v 1.3 2002/09/14 06:43:59 jeffc Exp $
____________________________________________________________________________*/

#import "PGPUICocoaPriv.h"
#import "pgpPFLErrors.h"
#import "pgpKeys.h"

NSString* PGPUIGetPrimaryUserIDName(PGPKeyDBObjRef key)
{
	char						cstr[kPGPUI_MaxPGPUserIDLength];
	NSString					*name = nil;
	PGPSize						len;
	
	if( IsntPGPError( PGPGetPrimaryUserIDName( key, cstr, kPGPUI_MaxPGPUserIDLength - 1, &len ) ) )
	{
		name = [NSString stringWithUTF8String:cstr];
		
		if (!name)
		{
			name = [[[NSString alloc] initWithData:[NSData dataWithBytes:cstr length:len] encoding:NSMacOSRomanStringEncoding] autorelease];
		}
	}
	return name;
}


NSString* PGPUIGetUserIDName(PGPKeyDBObjRef userID)
{
	char						cstr[kPGPUI_MaxPGPUserIDLength];
	NSString					*name = nil;
	PGPSize						len;
	
	if( IsntPGPError( PGPGetKeyDBObjDataProperty( userID, kPGPUserIDProperty_Name,
		cstr, kPGPUI_MaxPGPUserIDLength - 1, &len ) ) )
	{
		name = [NSString stringWithUTF8String:cstr];
		
		if (!name)
		{
			name = [[[NSString alloc] initWithData:[NSData dataWithBytes:cstr length:len] encoding:NSMacOSRomanStringEncoding] autorelease];
		}
	}
	return name;
}

