/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	$Id: PGPuiframework.mm,v 1.5 2002/08/23 02:38:36 jason Exp $
____________________________________________________________________________*/

#import "pgpSDKUILibPriv.h"
#import "pgpDialogs.h"
#import "PGPDialogProxies.h"
#import "PGPDialogClasses.h"
#import "PGPuiframework.h"


	
static PGPuiframework *		sFramework = NULL;


@implementation PGPuiframework

	- (void)
call2ParamFunction
	:(id)	params
{
	NSAutoreleasePool *	pool = [[NSAutoreleasePool alloc] init];
	PGPui2ParamCall		call = (PGPui2ParamCall)[[params objectForKey:@"call"] pointerValue];
	void *				param1 = [[params objectForKey:@"param1"] pointerValue];
	void *				param2 = [[params objectForKey:@"param2"] pointerValue];
	PGPError			result = call(param1, param2);

	[params setObject:[NSValue value:&result withObjCType:@encode(PGPError)] forKey:@"result"];
	[pool release];
}

@end



	static PGPError
sCall2ParamFunction(
	PGPui2ParamCall	call,
	void *			param1,
	void *			param2)
{
	PGPError				result = kPGPError_ImproperInitialization;
	NSAutoreleasePool *		pool = [[NSAutoreleasePool alloc] init];
	
	if (sFramework) {
		NSMutableDictionary *	params = [NSMutableDictionary dictionaryWithObjectsAndKeys:[NSValue value:&call withObjCType:@encode(PGPui2ParamCall)], @"call",
											[NSValue value:&param1 withObjCType:@encode(void *)], @"param1",
											[NSValue value:&param2 withObjCType:@encode(void *)], @"param2", nil];
		
		[sFramework performSelectorOnMainThread:@selector(call2ParamFunction:) withObject:params waitUntilDone:TRUE];
		[[params objectForKey:@"result"] getValue:&result];
	}
	[pool release];
	
	return result;
}


	PGPError
pgpRecipientDialogPlatform(
	PGPContextRef					context,
	CPGPRecipientDialogOptions *	options)
{
	return sCall2ParamFunction((PGPui2ParamCall)pgpRecipientDialogPlatformMain, context, options);
}



	PGPError
pgpPassphraseDialogPlatform(
	PGPContextRef					context,
	CPGPPassphraseDialogOptions *	options)
{
	return sCall2ParamFunction((PGPui2ParamCall)pgpPassphraseDialogPlatformMain, context, options);
}



	PGPError
pgpKeyPassphraseDialogPlatform(
	PGPContextRef						context,
	CPGPKeyPassphraseDialogOptions *	options)
{
	return sCall2ParamFunction((PGPui2ParamCall)pgpKeyPassphraseDialogPlatformMain, context, options);
}



	PGPError
pgpSigningPassphraseDialogPlatform(
	PGPContextRef							context,
	CPGPSigningPassphraseDialogOptions *	options)
{
	return sCall2ParamFunction((PGPui2ParamCall)pgpSigningPassphraseDialogPlatformMain, context, options);
}



	PGPError
pgpDecryptionPassphraseDialogPlatform(
	PGPContextRef							context,
	CPGPDecryptionPassphraseDialogOptions *	options)
{
	return sCall2ParamFunction((PGPui2ParamCall)pgpDecryptionPassphraseDialogPlatformMain, context, options);
}



	PGPError
pgpConfirmationPassphraseDialogPlatform(
	PGPContextRef								context,
	CPGPConfirmationPassphraseDialogOptions *	options)
{
	return sCall2ParamFunction((PGPui2ParamCall)pgpConfirmationPassphraseDialogPlatformMain, context, options);
}



	PGPError
pgpOptionsDialogPlatform(
	PGPContextRef				context,
	CPGPOptionsDialogOptions *	options)
{
	return sCall2ParamFunction((PGPui2ParamCall)pgpOptionsDialogPlatformMain, context, options);
}



	PGPError
pgpCollectRandomDataDialogPlatform(
	PGPContextRef					context,
	CPGPRandomDataDialogOptions *	options)
{
	return sCall2ParamFunction((PGPui2ParamCall)pgpCollectRandomDataDialogPlatformMain, context, options);
}



	PGPError
pgpSearchKeyServerDialogPlatform(
	PGPContextRef						context,
	CPGPSearchKeyServerDialogOptions *	options)
{
	return sCall2ParamFunction((PGPui2ParamCall)pgpSearchKeyServerDialogPlatformMain, context, options);
}



	PGPError
pgpSendToKeyServerDialogPlatform(
	PGPContextRef						context,
	CPGPSendToKeyServerDialogOptions *	options)
{
	return sCall2ParamFunction((PGPui2ParamCall)pgpSendToKeyServerDialogPlatformMain, context, options);
}



	PGPError
PGPsdkUILibInitPlatform()
{
	PGPError			result = kPGPError_NoErr;
	NSAutoreleasePool *	pool = [[NSAutoreleasePool alloc] init];
	
	NSApplicationLoad();
	if (sFramework) {
		[sFramework release];
		sFramework = NULL;
	}
	sFramework = [[PGPuiframework alloc] init];
	if (! sFramework) {
		result = kPGPError_ImproperInitialization;
	}
	[pool release];
	
	return result;
}



	void
PGPsdkUILibCleanupPlatform()
{
	NSAutoreleasePool *	pool = [[NSAutoreleasePool alloc] init];
	
	[sFramework release];
	sFramework = NULL;
	[pool release];
}