/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	$Id: CPGPDialog.m,v 1.2 2002/08/06 20:10:56 dallen Exp $
____________________________________________________________________________*/

#import "PGPDialogClasses.h"

@implementation CPGPDialog

- (PGPDialogProxyObjRef)proxyObject
{
	return mProxyObject;
}

- (void)setProxyObject:(PGPDialogProxyObjRef)proxyObject
{
	mProxyObject = proxyObject;
}

- (PGPContextRef)context
{
	return mContext;
}

- (void)setContext:(PGPContextRef)context
{
	mContext = context;
}

- (PGPOptionListRef)clientOptions
{
	return mClientOptions;
}

- (void)setClientOptions:(PGPOptionListRef)options
{
	mClientOptions = options;
}

- (NSString*)windowTitle
{
	return [mWindow title];
}

- (void)setWindowTitle:(NSString*)title
{
	if (title)
		[mWindow setTitle:title];
	else
		[mWindow setTitle:@""];
}

- (PGPKeyServerSpec*)serverList
{
	return mServerList;
}

- (void)setServerList:(PGPKeyServerSpec*)serverList
{
	mServerList = serverList;
}

- (PGPUInt32)serverCount
{
	return mServerCount;
}

- (void)setServerCount:(PGPUInt32)serverCount
{
	mServerCount = serverCount;
}

- (PGPBoolean)searchBeforeDisplay
{
	return mSearchBeforeDisplay;
}

- (void)setSearchBeforeDisplay:(PGPBoolean)flag
{
	mSearchBeforeDisplay = flag;
}

- (PGPKeyDBRef*)newKeys
{
	return mNewKeys;
}

- (void)setNewKeys:(PGPKeyDBRef*)newKeys
{
	mNewKeys = newKeys;
}

- (PGPtlsContextRef)tlsContext
{
	return mTLSContext;
}

- (void)setTLSContext:(PGPtlsContextRef)tlsContext
{
	mTLSContext = tlsContext;
}

- (PGPKeyDBObjRef)defaultKey
{
	return mDefaultKey;
}

- (void)setDefaultKey:(PGPKeyDBObjRef)key
{
	mDefaultKey = key;
}

- (NSString*)prompt
{
	return [mPrompt stringValue];
}

- (void)setPrompt:(NSString*)prompt
{
	if (prompt)
		[mPrompt setStringValue:prompt];
	else
		[mPrompt setStringValue:@""];
}

- (PGPError)runDialog
{
	[NSApp runModalForWindow:mWindow];
	
	return mReturnCode;
}

- (PGPError)returnCode
{
	return mReturnCode;
}

- (BOOL)windowShouldClose:(id)sender
{
	return YES;
}

@end
