/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	
	
	$Id: CCRSVerisignServer.h,v 1.5 2002/08/06 20:11:11 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CCRSVerisignServer_h
#define Included_CCRSVerisignServer_h

#include "CCRSServer.h"

class CCRSVerisignServer : public CCRSServer {
public:
					CCRSVerisignServer(PGPContextRef inContext,
						const char * inHostName, PGPUInt32 inHostAddress,
						PGPUInt16 inHostPort, const char * inPath,
						PGPKeyServerProtocol inProtocol,
						PGPKeyServerClass inClass);
	virtual			~CCRSVerisignServer();
	
	virtual void	SendCertificateRequest(PGPKeyDBObjRef inCAKey, PGPKeyDBObjRef inRequestKey, 
						const void * inBuffer, PGPSize inBufferSize, void ** outBuffer,
						PGPSize * outBufferSize);
	virtual void	RetrieveCertificate(PGPFilterRef inSearchFilter, PGPKeyDBObjRef inSearchKey,
	    					PGPKeyDBObjRef inCAKey,
						PGPKeyDBObjRef inSigningKey, PGPByte * inPassphrase,
						PGPSize inPassphraseLength, PGPBoolean inIsPassphrase,
						void ** outBuffer, PGPSize * outBufferSize);
	virtual void	RetrieveCRL(PGPKeyDBObjRef inCAKey, PGPKeyDBObjRef inSigningKey,
						PGPByte * inPassphrase, PGPSize inPassphraseLength,
						PGPBoolean inIsPassphrase, void ** outBuffer, PGPSize * outBufferSize);

protected:
	PGPUInt32		PostCRSMessage(PGPKeyServerState inOperation, const char * inPath,
						PGPByte** outResult, PGPUInt32 inContentLength,
						const PGPByte * inData);

	void			PackageAndSendCRSMessage(PGPExportFormat inExportFormat,
						PGPOutputFormat inOutputFormat, PGPKeyDBObjRef inKey, PGPKeyDBObjRef inSigningKey,
						PGPByte * inPassphrase, PGPSize inPassphraseLength,
						PGPBoolean inIsPassphrase, void ** outBuffer, PGPSize * outBufferSize);
};



#endif
